searchNodes=[{"ref":"K8s.html","title":"K8s","type":"module","doc":"Kubernetes API Client for Elixir"},{"ref":"K8s.Client.html","title":"K8s.Client","type":"module","doc":"An experimental k8s client. Functions return K8s.Operations that represent kubernetes operations. To run operations pass them to: run/2, run/3, or run/4. When specifying kinds the format should either be in the literal kubernetes kind name (eg &quot;ServiceAccount&quot;) or the downcased version seen in kubectl (eg &quot;serviceaccount&quot;). A string or atom may be used. Examples &quot;Deployment&quot;, &quot;deployment&quot;, :Deployment, :deployment &quot;ServiceAccount&quot;, &quot;serviceaccount&quot;, :ServiceAccount, :serviceaccount &quot;HorizontalPodAutoscaler&quot;, &quot;horizontalpodautoscaler&quot;, :HorizontalPodAutoscaler, :horizontalpodautoscaler opts to K8s.Client.Runner modules are HTTPoison HTTP option overrides."},{"ref":"K8s.Client.html#async/2","title":"K8s.Client.async/2","type":"function","doc":"alias of K8s.Client.Runner.Async.run/3"},{"ref":"K8s.Client.html#async/3","title":"K8s.Client.async/3","type":"function","doc":"alias of K8s.Client.Runner.Async.run/3"},{"ref":"K8s.Client.html#create/1","title":"K8s.Client.create/1","type":"function","doc":"Returns a POSTK8s.Operation to create the given resource. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.create(deployment) %K8s.Operation{ method: :post, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;], verb: :create, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, data: %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } }"},{"ref":"K8s.Client.html#create/2","title":"K8s.Client.create/2","type":"function","doc":"Returns a POSTK8s.Operation to create the given subresource. Used for creating subresources like Scale or Eviction. Examples Eviction a pod iex&gt; pod = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;default&quot; ...&gt; } ...&gt; } ...&gt; eviction = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Eviction&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;default&quot; ...&gt; } ...&gt; } ...&gt; K8s.Client.create(pod, eviction) %K8s.Operation{api_version: &quot;v1&quot;, data: %{&quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot;, &quot;kind&quot; =&gt; &quot;Eviction&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;default&quot;}}, method: :post, name: {&quot;Pod&quot;, &quot;Eviction&quot;}, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], verb: :create}"},{"ref":"K8s.Client.html#create/4","title":"K8s.Client.create/4","type":"function","doc":"Returns a POSTK8s.Operation to create the given subresource. Used for creating subresources like Scale or Eviction. Examples Eviction a pod iex&gt; eviction = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Eviction&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;default&quot; ...&gt; } ...&gt; } ...&gt; K8s.Client.create(&quot;v1&quot;, &quot;pods/eviction&quot;, [namespace: &quot;default&quot;, name: &quot;nginx&quot;], eviction) %K8s.Operation{api_version: &quot;v1&quot;, data: %{&quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot;, &quot;kind&quot; =&gt; &quot;Eviction&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;default&quot;}}, method: :post, name: &quot;pods/eviction&quot;, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], verb: :create}"},{"ref":"K8s.Client.html#delete/1","title":"K8s.Client.delete/1","type":"function","doc":"Returns a DELETE operation for a resource by manifest. May be a partial manifest as long as it contains: apiVersion kind metadata.name metadata.namespace (if applicable) K8s Docs: Delete will delete a resource. Depending on the specific resource, child objects may or may not be garbage collected by the server. See notes on specific resource objects for details. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.delete(deployment) %K8s.Operation{ method: :delete, verb: :delete, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;] }"},{"ref":"K8s.Client.html#delete/3","title":"K8s.Client.delete/3","type":"function","doc":"Returns a DELETE operation for a resource by version, kind, name, and optionally namespace. Examples iex&gt; K8s.Client.delete(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :delete, verb: :delete, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;] }"},{"ref":"K8s.Client.html#delete_all/2","title":"K8s.Client.delete_all/2","type":"function","doc":"Returns a DELETE collection operation for all instances of a cluster scoped resource kind. Examples iex&gt; K8s.Client.delete_all(&quot;extensions/v1beta1&quot;, &quot;PodSecurityPolicy&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, api_version: &quot;extensions/v1beta1&quot;, name: &quot;PodSecurityPolicy&quot;, path_params: [] } iex&gt; K8s.Client.delete_all(&quot;storage.k8s.io/v1&quot;, &quot;StorageClass&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, api_version: &quot;storage.k8s.io/v1&quot;, name: &quot;StorageClass&quot;, path_params: [] }"},{"ref":"K8s.Client.html#delete_all/3","title":"K8s.Client.delete_all/3","type":"function","doc":"Returns a DELETE collection operation for all instances of a resource kind in a specific namespace. Examples iex&gt; K8s.Client.delete_all(&quot;apps/v1beta1&quot;, &quot;ControllerRevision&quot;, namespace: &quot;default&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, api_version: &quot;apps/v1beta1&quot;, name: &quot;ControllerRevision&quot;, path_params: [namespace: &quot;default&quot;] } iex&gt; K8s.Client.delete_all(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;staging&quot;) %K8s.Operation{ method: :delete, verb: :deletecollection, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;staging&quot;] }"},{"ref":"K8s.Client.html#get/1","title":"K8s.Client.get/1","type":"function","doc":"Returns a GET operation for a resource given a manifest. May be a partial manifest as long as it contains: apiVersion kind metadata.name metadata.namespace (if applicable) K8s Docs: Get will retrieve a specific resource object by name. Examples Getting a pod iex&gt; pod = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot;, ...&gt; &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx-pod&quot;, &quot;namespace&quot; =&gt; &quot;test&quot;}, ...&gt; &quot;spec&quot; =&gt; %{&quot;containers&quot; =&gt; %{&quot;image&quot; =&gt; &quot;nginx&quot;}} ...&gt; } ...&gt; K8s.Client.get(pod) %K8s.Operation{ method: :get, verb: :get, api_version: &quot;v1&quot;, name: &quot;Pod&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx-pod&quot;], }"},{"ref":"K8s.Client.html#get/3","title":"K8s.Client.get/3","type":"function","doc":"Returns a GET operation for a resource by version, kind/resource type, name, and optionally namespace. K8s Docs: Get will retrieve a specific resource object by name. Examples Get the nginx deployment in the default namespace: iex&gt; K8s.Client.get(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :get, verb: :get, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;] } Get the nginx deployment in the default namespace: iex&gt; K8s.Client.get(&quot;apps/v1&quot;, :deployment, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :get, verb: :get, api_version: &quot;apps/v1&quot;, name: :deployment, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;]} Get the nginx deployment&#39;s status: iex&gt; K8s.Client.get(&quot;apps/v1&quot;, &quot;deployments/status&quot;, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :get, verb: :get, api_version: &quot;apps/v1&quot;, name: &quot;deployments/status&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;]} Get the nginx deployment&#39;s scale: iex&gt; K8s.Client.get(&quot;v1&quot;, &quot;deployments/scale&quot;, namespace: &quot;test&quot;, name: &quot;nginx&quot;) %K8s.Operation{ method: :get, verb: :get, api_version: &quot;v1&quot;, name: &quot;deployments/scale&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;]}"},{"ref":"K8s.Client.html#list/3","title":"K8s.Client.list/3","type":"function","doc":"Returns a GET operation to list all resources by version, kind, and namespace. Given the namespace :all as an atom, will perform a list across all namespaces. K8s Docs: List will retrieve all resource objects of a specific type within a namespace, and the results can be restricted to resources matching a selector query. List All Namespaces: Like List but retrieves resources across all namespaces. Examples iex&gt; K8s.Client.list(&quot;v1&quot;, &quot;Pod&quot;, namespace: &quot;default&quot;) %K8s.Operation{ method: :get, verb: :list, api_version: &quot;v1&quot;, name: &quot;Pod&quot;, path_params: [namespace: &quot;default&quot;] } iex&gt; K8s.Client.list(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: :all) %K8s.Operation{ method: :get, verb: :list_all_namespaces, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [] }"},{"ref":"K8s.Client.html#parallel/3","title":"K8s.Client.parallel/3","type":"function","doc":"alias of K8s.Client.Runner.Async.run/3"},{"ref":"K8s.Client.html#patch/1","title":"K8s.Client.patch/1","type":"function","doc":"Returns a PATCH operation to patch the given resource. K8s Docs: Patch will apply a change to a specific field. How the change is merged is defined per field. Lists may either be replaced or merged. Merging lists will not preserve ordering. Patches will never cause optimistic locking failures, and the last write will win. Patches are recommended when the full state is not read before an update, or when failing on optimistic locking is undesirable. When patching complex types, arrays and maps, how the patch is applied is defined on a per-field basis and may either replace the field&#39;s current value, or merge the contents into the current value. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.patch(deployment) %K8s.Operation{ method: :patch, verb: :patch, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;], data: %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } }"},{"ref":"K8s.Client.html#patch/2","title":"K8s.Client.patch/2","type":"function","doc":"Returns a PATCH operation to patch the given subresource given a resource map and a subresource map."},{"ref":"K8s.Client.html#patch/4","title":"K8s.Client.patch/4","type":"function","doc":"Returns a PATCH operation to patch the given subresource given a resource&#39;s details and a subresource map."},{"ref":"K8s.Client.html#run/2","title":"K8s.Client.run/2","type":"function","doc":"alias of K8s.Client.Runner.Base.run/2"},{"ref":"K8s.Client.html#run/3","title":"K8s.Client.run/3","type":"function","doc":"alias of K8s.Client.Runner.Base.run/3"},{"ref":"K8s.Client.html#run/4","title":"K8s.Client.run/4","type":"function","doc":"alias of K8s.Client.Runner.Base.run/4"},{"ref":"K8s.Client.html#stream/2","title":"K8s.Client.stream/2","type":"function","doc":"alias of K8s.Client.Runner.Stream.run/2"},{"ref":"K8s.Client.html#stream/3","title":"K8s.Client.stream/3","type":"function","doc":"alias of K8s.Client.Runner.Stream.run/3"},{"ref":"K8s.Client.html#update/1","title":"K8s.Client.update/1","type":"function","doc":"Returns a PUT operation to replace/update the given resource. K8s Docs: Replacing a resource object will update the resource by replacing the existing spec with the provided one. For read-then-write operations this is safe because an optimistic lock failure will occur if the resource was modified between the read and write. Note: The ResourceStatus will be ignored by the system and will not be updated. To update the status, one must invoke the specific status update operation. Note: Replacing a resource object may not result immediately in changes being propagated to downstream objects. For instance replacing a ConfigMap or Secret resource will not result in all Pods seeing the changes unless the Pods are restarted out of band. Examples iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Client.update(deployment) %K8s.Operation{ method: :put, verb: :update, api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot;, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;], data: %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } }"},{"ref":"K8s.Client.html#update/2","title":"K8s.Client.update/2","type":"function","doc":"Returns a PUT operation to replace/update the given subresource given a resource map and a subresource map. Used for updating subresources like Scale or Status. Examples Scaling a deployment: iex&gt; deployment = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; }, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 2, ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;containers&quot; =&gt; %{ ...&gt; &quot;image&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; scale = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Scale&quot;, ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1beta1&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;test&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 3 ...&gt; } ...&gt; } ...&gt; K8s.Client.update(deployment, scale) %K8s.Operation{api_version: &quot;apps/v1&quot;, method: :put, path_params: [namespace: &quot;test&quot;, name: &quot;nginx&quot;], verb: :update, data: %{&quot;apiVersion&quot; =&gt; &quot;apps/v1beta1&quot;, &quot;kind&quot; =&gt; &quot;Scale&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot;}, &quot;spec&quot; =&gt; %{&quot;replicas&quot; =&gt; 3}}, name: {&quot;Deployment&quot;, &quot;Scale&quot;}}"},{"ref":"K8s.Client.html#update/4","title":"K8s.Client.update/4","type":"function","doc":"Returns a PUT operation to replace/update the given subresource given a resource&#39;s details and a subresource map. Used for updating subresources like Scale or Status. Examples Scaling a deployment iex&gt; scale = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Scale&quot;, ...&gt; &quot;apiVersion&quot; =&gt; &quot;apps/v1beta1&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;namespace&quot; =&gt; &quot;default&quot; ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;replicas&quot; =&gt; 3 ...&gt; } ...&gt; } ...&gt; K8s.Client.update(&quot;apps/v1&quot;, &quot;deployments/scale&quot;, [namespace: &quot;default&quot;, name: &quot;nginx&quot;], scale) %K8s.Operation{api_version: &quot;apps/v1&quot;, data: %{&quot;apiVersion&quot; =&gt; &quot;apps/v1beta1&quot;, &quot;kind&quot; =&gt; &quot;Scale&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;default&quot;}, &quot;spec&quot; =&gt; %{&quot;replicas&quot; =&gt; 3}}, method: :put, name: &quot;deployments/scale&quot;, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], verb: :update}"},{"ref":"K8s.Client.html#wait_until/3","title":"K8s.Client.wait_until/3","type":"function","doc":"alias of K8s.Client.Runner.Wait.run/3"},{"ref":"K8s.Client.html#watch/3","title":"K8s.Client.watch/3","type":"function","doc":"alias of K8s.Client.Runner.Watch.run/3"},{"ref":"K8s.Client.html#watch/4","title":"K8s.Client.watch/4","type":"function","doc":"alias of K8s.Client.Runner.Watch.run/4"},{"ref":"K8s.Client.html#t:option/0","title":"K8s.Client.option/0","type":"type","doc":""},{"ref":"K8s.Client.html#t:options/0","title":"K8s.Client.options/0","type":"type","doc":""},{"ref":"K8s.Client.DynamicHTTPProvider.html","title":"K8s.Client.DynamicHTTPProvider","type":"module","doc":"Allows for registration of K8s.Client.Provider handlers per-process. Used internally by the test suite for testing/mocking Kubernetes responses."},{"ref":"K8s.Client.DynamicHTTPProvider.html#child_spec/1","title":"K8s.Client.DynamicHTTPProvider.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"K8s.Client.DynamicHTTPProvider.html#list/0","title":"K8s.Client.DynamicHTTPProvider.list/0","type":"function","doc":"List all registered handlers"},{"ref":"K8s.Client.DynamicHTTPProvider.html#lookup/1","title":"K8s.Client.DynamicHTTPProvider.lookup/1","type":"function","doc":"Lookup the handler module for this process"},{"ref":"K8s.Client.DynamicHTTPProvider.html#register/2","title":"K8s.Client.DynamicHTTPProvider.register/2","type":"function","doc":"Register the handler mdoule for this process"},{"ref":"K8s.Client.DynamicHTTPProvider.html#request/5","title":"K8s.Client.DynamicHTTPProvider.request/5","type":"function","doc":"Dispatch request/5 to the module registered in the current process. If the current process is not register, check its parent. This is useful when requests are made from child processes e.g.: (Task.async/1)"},{"ref":"K8s.Client.DynamicHTTPProvider.html#start_link/1","title":"K8s.Client.DynamicHTTPProvider.start_link/1","type":"function","doc":"Starts this provider."},{"ref":"K8s.Client.HTTPProvider.html","title":"K8s.Client.HTTPProvider","type":"module","doc":"HTTPoison and Jason based K8s.Client.Provider"},{"ref":"K8s.Client.HTTPProvider.html#handle_response/1","title":"K8s.Client.HTTPProvider.handle_response/1","type":"function","doc":"Handle HTTPoison responses and errors Examples Parses successful JSON responses: iex&gt; body = ~s({&quot;foo&quot;: &quot;bar&quot;}) ...&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 200, body: body}}) {:ok, %{&quot;foo&quot; =&gt; &quot;bar&quot;}} Parses successful JSON responses: iex&gt; body = &quot;line 1\\nline 2\\nline 3\\n&quot; ...&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 200, body: body, headers: [{&quot;Content-Type&quot;, &quot;text/plain&quot;}]}}) {:ok, &quot;line 1\\nline 2\\nline 3\\n&quot;} Handles unauthorized responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 401}}) {:error, :unauthorized} Handles not found responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 404}}) {:error, :not_found} Passes through HTTPoison 4xx responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:ok, %HTTPoison.Response{status_code: 410, body: &quot;Gone&quot;}}) {:error, %HTTPoison.Response{status_code: 410, body: &quot;Gone&quot;}} Passes through HTTPoison error responses: iex&gt; K8s.Client.HTTPProvider.handle_response({:error, %HTTPoison.Error{reason: &quot;Foo&quot;}}) {:error, %HTTPoison.Error{reason: &quot;Foo&quot;}}"},{"ref":"K8s.Client.HTTPProvider.html#headers/2","title":"K8s.Client.HTTPProvider.headers/2","type":"function","doc":"Generates HTTP headers from K8s.Conn.RequestOptions Adds {&quot;Accept&quot;, &quot;application/json&quot;} to all requests. Adds Content-Type base on HTTP method. Example Sets Content-Type to application/merge-patch+json for PATCH operations iex&gt; opts = %K8s.Conn.RequestOptions{headers: [{&quot;Authorization&quot;, &quot;Basic AF&quot;}]} ...&gt; K8s.Client.HTTPProvider.headers(:patch, opts) [{&quot;Accept&quot;, &quot;application/json&quot;}, {&quot;Content-Type&quot;, &quot;application/merge-patch+json&quot;}, {&quot;Authorization&quot;, &quot;Basic AF&quot;}] Sets Content-Type to application/json for all other operations iex&gt; opts = %K8s.Conn.RequestOptions{headers: [{&quot;Authorization&quot;, &quot;Basic AF&quot;}]} ...&gt; K8s.Client.HTTPProvider.headers(:get, opts) [{&quot;Accept&quot;, &quot;application/json&quot;}, {&quot;Content-Type&quot;, &quot;application/json&quot;}, {&quot;Authorization&quot;, &quot;Basic AF&quot;}]"},{"ref":"K8s.Client.Provider.html","title":"K8s.Client.Provider","type":"behaviour","doc":"HTTP Request / Response provider behaviour"},{"ref":"K8s.Client.Provider.html#c:handle_response/1","title":"K8s.Client.Provider.handle_response/1","type":"callback","doc":"Handle HTTP Responses"},{"ref":"K8s.Client.Provider.html#c:headers/2","title":"K8s.Client.Provider.headers/2","type":"callback","doc":"Generate headers for HTTP Requests"},{"ref":"K8s.Client.Provider.html#c:request/5","title":"K8s.Client.Provider.request/5","type":"callback","doc":"Perform HTTP Requests"},{"ref":"K8s.Client.Provider.html#t:error_t/0","title":"K8s.Client.Provider.error_t/0","type":"type","doc":""},{"ref":"K8s.Client.Provider.html#t:response_t/0","title":"K8s.Client.Provider.response_t/0","type":"type","doc":""},{"ref":"K8s.Client.Provider.html#t:success_t/0","title":"K8s.Client.Provider.success_t/0","type":"type","doc":""},{"ref":"K8s.Client.Runner.Async.html","title":"K8s.Client.Runner.Async","type":"module","doc":"K8s.Client runner to process a batch of operations in parallel."},{"ref":"K8s.Client.Runner.Async.html#run/3","title":"K8s.Client.Runner.Async.run/3","type":"function","doc":"Runs multiple operations in parallel. Operations will be returned in same order given. Operations will not cease in event of failure. Example Get a list of pods, then map each one to an individual GET operation: # Get the pods operation = K8s.Client.list(&quot;v1&quot;, &quot;Pod&quot;, namespace: :all) {:ok, %{&quot;items&quot; =&gt; pods}} = K8s.Client.run(operation, :test_cluster) # Map each one to an individual `GET` operation. operations = Enum.map(pods, fn(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; name, &quot;namespace&quot; =&gt; ns}}) -&gt; K8s.Client.get(&quot;v1&quot;, &quot;Pod&quot;, namespace: ns, name: name) end) # Get the results asynchronously results = K8s.Client.Async.run(operations, :test_cluster)"},{"ref":"K8s.Client.Runner.Base.html","title":"K8s.Client.Runner.Base","type":"module","doc":"Base HTTP processor for K8s.Client"},{"ref":"K8s.Client.Runner.Base.html#run/2","title":"K8s.Client.Runner.Base.run/2","type":"function","doc":"Runs a K8s.Operation. Examples Note: Examples assume a K8s.Conn was configured named :test. See K8s.Conn.Config. Running a list pods operation: conn = K8s.Conn.lookup(:test) operation = K8s.Client.list(&quot;v1&quot;, &quot;Pod&quot;, namespace: :all) {:ok, %{&quot;items&quot; =&gt; pods}} = K8s.Client.run(operation, conn) Running a dry-run of a create deployment operation: deployment = %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; }, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;test&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2, &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } }, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot;, &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } operation = K8s.Client.create(deployment) conn = K8s.Conn.lookup(:tes) # opts is passed to HTTPoison as opts. opts = [params: %{&quot;dryRun&quot; =&gt; &quot;all&quot;}] :ok = K8s.Client.Runner.Base.run(operation, conn, opts)"},{"ref":"K8s.Client.Runner.Base.html#run/3","title":"K8s.Client.Runner.Base.run/3","type":"function","doc":"Run an operation and pass opts to HTTPoison. Destructures Operation data and passes as the HTTP body. See run/2"},{"ref":"K8s.Client.Runner.Base.html#run/4","title":"K8s.Client.Runner.Base.run/4","type":"function","doc":"Run an operation with an HTTP Body (map) and pass opts to HTTPoison. See run/2"},{"ref":"K8s.Client.Runner.Base.html#t:body_t/0","title":"K8s.Client.Runner.Base.body_t/0","type":"type","doc":"Acceptable HTTP body types"},{"ref":"K8s.Client.Runner.Base.html#t:result_t/0","title":"K8s.Client.Runner.Base.result_t/0","type":"type","doc":""},{"ref":"K8s.Client.Runner.Stream.html","title":"K8s.Client.Runner.Stream","type":"module","doc":"Takes a K8s.Client.list/3 operation and returns an Elixir Stream"},{"ref":"K8s.Client.Runner.Stream.html#run/3","title":"K8s.Client.Runner.Stream.run/3","type":"function","doc":"Validates operation type before calling stream/3. Only supports verbs: list_all_namespaces and list."},{"ref":"K8s.Client.Runner.Stream.html#stream/3","title":"K8s.Client.Runner.Stream.stream/3","type":"function","doc":"Returns an elixir stream of paginated list results. Elements in stream will be HTTP bodies, or error tuples. Encountering an HTTP error mid-stream will halt the stream."},{"ref":"K8s.Client.Runner.Stream.html#t:halt_t/0","title":"K8s.Client.Runner.Stream.halt_t/0","type":"type","doc":"Halt streaming"},{"ref":"K8s.Client.Runner.Stream.html#t:state_t/0","title":"K8s.Client.Runner.Stream.state_t/0","type":"type","doc":"List of items and pagination request"},{"ref":"K8s.Client.Runner.Stream.ListRequest.html","title":"K8s.Client.Runner.Stream.ListRequest","type":"module","doc":":listK8s.Operation encapsulated with pagination and K8s.Conn"},{"ref":"K8s.Client.Runner.Stream.ListRequest.html#make_next_request/2","title":"K8s.Client.Runner.Stream.ListRequest.make_next_request/2","type":"function","doc":"Creates a ListRequest struct for the next HTTP request from the previous HTTP response"},{"ref":"K8s.Client.Runner.Stream.ListRequest.html#t:continue_t/0","title":"K8s.Client.Runner.Stream.ListRequest.continue_t/0","type":"type","doc":"Pagination continue token"},{"ref":"K8s.Client.Runner.Stream.ListRequest.html#t:opts_t/0","title":"K8s.Client.Runner.Stream.ListRequest.opts_t/0","type":"type","doc":"opts for Base.run/3"},{"ref":"K8s.Client.Runner.Stream.ListRequest.html#t:t/0","title":"K8s.Client.Runner.Stream.ListRequest.t/0","type":"type","doc":"List operation as a Stream data type"},{"ref":"K8s.Client.Runner.Wait.html","title":"K8s.Client.Runner.Wait","type":"module","doc":"Waiting functionality for K8s.Client. Note: This is built using repeated GET operations rather than using a watch operation w/ fieldSelector."},{"ref":"K8s.Client.Runner.Wait.html#run/3","title":"K8s.Client.Runner.Wait.run/3","type":"function","doc":"Continually perform a GET based operation until a condition is met. Example Checking the number of job completions: op = K8s.Client.get(&quot;batch/v1&quot;, :job, namespace: &quot;default&quot;, name: &quot;sleep&quot;) opts = [find: [&quot;status&quot;, &quot;succeeded&quot;], eval: 1, timeout: 60] resp = K8s.Client.Runner.Wait.run(op, cluster_name, opts)"},{"ref":"K8s.Client.Runner.Wait.html#t:t/0","title":"K8s.Client.Runner.Wait.t/0","type":"type","doc":"A wait configuration"},{"ref":"K8s.Client.Runner.Watch.html","title":"K8s.Client.Runner.Watch","type":"module","doc":"K8s.Client runner that will watch a resource or resources and stream results back to a process."},{"ref":"K8s.Client.Runner.Watch.html#run/3","title":"K8s.Client.Runner.Watch.run/3","type":"function","doc":"Watch a resource or list of resources. Provide the stream_to option or results will be stream to self(). Note: Current resource version will be looked up automatically. Examples conn = K8s.Conn.lookup(:test) operation = K8s.Client.list(&quot;v1&quot;, &quot;Namespace&quot;) {:ok, reference} = Watch.run(operation, conn, stream_to: self()) conn = K8s.Conn.lookup(:test) operation = K8s.Client.get(&quot;v1&quot;, &quot;Namespace&quot;, [name: &quot;test&quot;]) {:ok, reference} = Watch.run(operation, conn, stream_to: self())"},{"ref":"K8s.Client.Runner.Watch.html#run/4","title":"K8s.Client.Runner.Watch.run/4","type":"function","doc":"Watch a resource or list of resources from a specific resource version. Provide the stream_to option or results will be stream to self(). Examples conn = K8s.Conn.lookup(:test) operation = K8s.Client.list(&quot;v1&quot;, &quot;Namespace&quot;) resource_version = 3003 {:ok, reference} = Watch.run(operation, conn, resource_version, stream_to: self()) conn = K8s.Conn.lookup(:test) operation = K8s.Client.get(&quot;v1&quot;, &quot;Namespace&quot;, [name: &quot;test&quot;]) resource_version = 3003 {:ok, reference} = Watch.run(operation, conn, resource_version, stream_to: self())"},{"ref":"K8s.Conn.html","title":"K8s.Conn","type":"module","doc":"Handles authentication and connection configuration details for a Kubernetes cluster. Connections can be registered via Mix.Config or environment variables. Connections can also be dynaically built during application runtime."},{"ref":"K8s.Conn.html#from_file/2","title":"K8s.Conn.from_file/2","type":"function","doc":"Reads configuration details from a kubernetes config file. Defaults to current-context. Options context sets an alternate context cluster set or override the cluster read from the context user set or override the user read from the context discovery_driver module name to use for discovery discovery_opts options for discovery module"},{"ref":"K8s.Conn.html#from_service_account/1","title":"K8s.Conn.from_service_account/1","type":"function","doc":"Generates configuration from kubernetes service account Links kubernetes.io :: Accessing the API from a Pod"},{"ref":"K8s.Conn.html#from_service_account/2","title":"K8s.Conn.from_service_account/2","type":"function","doc":""},{"ref":"K8s.Conn.html#list/0","title":"K8s.Conn.list/0","type":"function","doc":"List of all registered connections. Connections are registered via Mix.Config or env variables. Examples K8s.Conn.list() [%K8s.Conn{ca_cert: nil, auth: %K8s.Conn.Auth{}, cluster_name: :&quot;docker-for-desktop-cluster&quot;, discovery_driver: K8s.Discovery.Driver.File, discovery_opts: [config: &quot;test/support/discovery/example.json&quot;], insecure_skip_tls_verify: true, url: &quot;https://localhost:6443&quot;, user_name: &quot;docker-for-desktop&quot;}]"},{"ref":"K8s.Conn.html#lookup/1","title":"K8s.Conn.lookup/1","type":"function","doc":"Lookup a registered connection by name. See K8s.Conn.Config. Examples K8s.Conn.lookup(:test) {:ok, %K8s.Conn{ca_cert: nil, auth: %K8s.Conn.Auth{}, cluster_name: :&quot;docker-for-desktop-cluster&quot;, discovery_driver: K8s.Discovery.Driver.File, discovery_opts: [config: &quot;test/support/discovery/example.json&quot;], insecure_skip_tls_verify: true, url: &quot;https://localhost:6443&quot;, user_name: &quot;docker-for-desktop&quot;}}"},{"ref":"K8s.Conn.html#t:t/0","title":"K8s.Conn.t/0","type":"type","doc":""},{"ref":"K8s.Conn.Auth.html","title":"K8s.Conn.Auth","type":"behaviour","doc":"Authorization behaviour"},{"ref":"K8s.Conn.Auth.html#c:create/2","title":"K8s.Conn.Auth.create/2","type":"callback","doc":""},{"ref":"K8s.Conn.Auth.AuthProvider.html","title":"K8s.Conn.Auth.AuthProvider","type":"module","doc":"auth-provider authentication support"},{"ref":"K8s.Conn.Auth.AuthProvider.html#generate_token/1","title":"K8s.Conn.Auth.AuthProvider.generate_token/1","type":"function","doc":"&quot;Generate&quot; a token using the auth-provider config in kube config."},{"ref":"K8s.Conn.Auth.AuthProvider.html#t:t/0","title":"K8s.Conn.Auth.AuthProvider.t/0","type":"type","doc":""},{"ref":"K8s.Conn.Auth.Certificate.html","title":"K8s.Conn.Auth.Certificate","type":"module","doc":"Certificate based cluster authentication."},{"ref":"K8s.Conn.Auth.Certificate.html#t:t/0","title":"K8s.Conn.Auth.Certificate.t/0","type":"type","doc":""},{"ref":"K8s.Conn.Auth.Token.html","title":"K8s.Conn.Auth.Token","type":"module","doc":"Token based cluster authentication"},{"ref":"K8s.Conn.Auth.Token.html#t:t/0","title":"K8s.Conn.Auth.Token.t/0","type":"type","doc":""},{"ref":"K8s.Conn.Config.html","title":"K8s.Conn.Config","type":"module","doc":"Add runtime cluster configuration with environment variables. Each variable consists of a prefix that determines where the value will be placed in the config and a suffix that is the cluster name. The cluster name will be atomized. Environment Variable Prefixes: K8S_CLUSTER_CONF_SA_ - boolean enables authentication to the k8s API with the pods spec.serviceAccountName. K8S_CLUSTER_CONF_PATH_ - string absolute path to the kube config file. K8S_CLUSTER_CONF_CONTEXT_ string which context to use in the kube config file. Examples export K8S_CLUSTER_CONF_SA_us_central=true export K8S_CLUSTER_CONF_PATH_us_east=&quot;east.yaml&quot; export K8S_CLUSTER_CONF_CONTEXT_us_east=&quot;east&quot; export K8S_CLUSTER_CONF_PATH_us_west=&quot;west.yaml&quot; export K8S_CLUSTER_CONF_CONTEXT_us_west=&quot;west&quot;"},{"ref":"K8s.Conn.Config.html#all/0","title":"K8s.Conn.Config.all/0","type":"function","doc":"Returns runtime and compile time cluster configuration merged together."},{"ref":"K8s.Conn.Config.html#compiletime_cluster_configs/0","title":"K8s.Conn.Config.compiletime_cluster_configs/0","type":"function","doc":""},{"ref":"K8s.Conn.Config.html#merge_configs/2","title":"K8s.Conn.Config.merge_configs/2","type":"function","doc":"Cluster configuration read from env variables. To be merged over Application.get_env(:k8s, :clusters). Examples Only specifying compiletime configs iex&gt; config = %{dev: %{conn: &quot;runtime/path/to/dev.kubeconfig.yaml&quot;}} ...&gt; K8s.Conn.Config.merge_configs(%{}, config) %{dev: %{conn: &quot;runtime/path/to/dev.kubeconfig.yaml&quot;}} Only specifying runtime configs iex&gt; env = %{&quot;K8S_CLUSTER_CONF_PATH_dev&quot; =&gt; &quot;runtime/path/to/dev.kubeconfig.yaml&quot;} ...&gt; K8s.Conn.Config.merge_configs(env, %{}) %{dev: %{conn: &quot;runtime/path/to/dev.kubeconfig.yaml&quot;}} Overriding compile time configs iex&gt; env = %{&quot;K8S_CLUSTER_CONF_PATH_dev&quot; =&gt; &quot;runtime/path/to/dev.kubeconfig.yaml&quot;} ...&gt; compile_config = %{dev: %{conn: &quot;compiletime/path/to/dev.kubeconfig.yaml&quot;}} ...&gt; K8s.Conn.Config.merge_configs(env, compile_config) %{dev: %{conn: &quot;runtime/path/to/dev.kubeconfig.yaml&quot;}} Merging compile time configs iex&gt; env = %{&quot;K8S_CLUSTER_CONF_CONTEXT_dev&quot; =&gt; &quot;runtime-context&quot;} ...&gt; compile_config = %{dev: %{conn: &quot;compiletime/path/to/dev.kubeconfig.yaml&quot;}} ...&gt; K8s.Conn.Config.merge_configs(env, compile_config) %{dev: %{conn: &quot;compiletime/path/to/dev.kubeconfig.yaml&quot;, conn_opts: [context: &quot;runtime-context&quot;]}} Adding clusters at runtime iex&gt; env = %{&quot;K8S_CLUSTER_CONF_PATH_us_east&quot; =&gt; &quot;runtime/path/to/us_east.kubeconfig.yaml&quot;, &quot;K8S_CLUSTER_CONF_CONTEXT_us_east&quot; =&gt; &quot;east-context&quot;} ...&gt; compile_config = %{us_west: %{conn: &quot;compiletime/path/to/us_west.kubeconfig.yaml&quot;}} ...&gt; K8s.Conn.Config.merge_configs(env, compile_config) %{us_east: %{conn: &quot;runtime/path/to/us_east.kubeconfig.yaml&quot;, conn_opts: [context: &quot;east-context&quot;]}, us_west: %{conn: &quot;compiletime/path/to/us_west.kubeconfig.yaml&quot;}}"},{"ref":"K8s.Conn.Config.html#runtime_cluster_configs/0","title":"K8s.Conn.Config.runtime_cluster_configs/0","type":"function","doc":"Parses ENV variables to runtime cluster configs"},{"ref":"K8s.Conn.PKI.html","title":"K8s.Conn.PKI","type":"module","doc":"Retrieves information from certificates"},{"ref":"K8s.Conn.PKI.html#cert_from_base64/1","title":"K8s.Conn.PKI.cert_from_base64/1","type":"function","doc":"Decodes the certificate from a base64 encoded string"},{"ref":"K8s.Conn.PKI.html#cert_from_map/2","title":"K8s.Conn.PKI.cert_from_map/2","type":"function","doc":"Reads the certificate from PEM file or base64 encoding"},{"ref":"K8s.Conn.PKI.html#cert_from_pem/1","title":"K8s.Conn.PKI.cert_from_pem/1","type":"function","doc":"Reads the certificate from a PEM file"},{"ref":"K8s.Conn.PKI.html#private_key_from_base64/1","title":"K8s.Conn.PKI.private_key_from_base64/1","type":"function","doc":"Decodes private key from a base64 encoded string"},{"ref":"K8s.Conn.PKI.html#private_key_from_pem/1","title":"K8s.Conn.PKI.private_key_from_pem/1","type":"function","doc":"Reads private key from a PEM file"},{"ref":"K8s.Conn.RequestOptions.html","title":"K8s.Conn.RequestOptions","type":"protocol","doc":"Encapsulates HTTP request options for an authentication provider."},{"ref":"K8s.Conn.RequestOptions.html#generate/1","title":"K8s.Conn.RequestOptions.generate/1","type":"function","doc":""},{"ref":"K8s.Conn.RequestOptions.html#t:generate_t/0","title":"K8s.Conn.RequestOptions.generate_t/0","type":"type","doc":"generate/1 response type"},{"ref":"K8s.Conn.RequestOptions.html#t:t/0","title":"K8s.Conn.RequestOptions.t/0","type":"type","doc":"HTTP Request options"},{"ref":"K8s.Discovery.html","title":"K8s.Discovery","type":"module","doc":"Kubernetes API Discovery"},{"ref":"K8s.Discovery.html#default_driver/0","title":"K8s.Discovery.default_driver/0","type":"function","doc":"Override the default driver for discovery. Each K8s.Conn can have its own driver set. If unset, this value will be used. Defaults to K8s.Discovery.Driver.HTTP Example mix config In the example below dev and test clusters will use the File driver, while prod will use the HTTP driver. use Mix.Config config :k8s, discovery_driver: K8s.Discovery.Driver.File, discovery_opts: [config: &quot;test/support/discovery/example.json&quot;], clusters: %{ test: %{ conn: &quot;test/support/kube-config.yaml&quot; }, dev: %{ conn: &quot;test/support/kube-config.yaml&quot; }, prod: %{ conn: &quot;test/support/kube-config.yaml&quot;, conn_opts: [ discovery_driver: K8s.Discovery.Driver.HTTP ] } }"},{"ref":"K8s.Discovery.html#default_opts/0","title":"K8s.Discovery.default_opts/0","type":"function","doc":"Override default opts for the discovery driver. This is also configurable per K8s.Conn"},{"ref":"K8s.Discovery.html#url_for/2","title":"K8s.Discovery.url_for/2","type":"function","doc":"Discovery the URL for a K8s.Conn and K8s.Operation Examples iex&gt; conn = K8s.Conn.from_file(&quot;./test/support/kube-config.yaml&quot;) ...&gt; op = K8s.Operation.build(:get, &quot;apps/v1&quot;, :deployments, [namespace: &quot;default&quot;, name: &quot;nginx&quot;]) ...&gt; K8s.Discovery.url_for(conn, op) {:ok, &quot;https://localhost:6443/apis/apps/v1/namespaces/default/deployments/nginx&quot;}"},{"ref":"K8s.Discovery.Driver.html","title":"K8s.Discovery.Driver","type":"behaviour","doc":"Driver behaviour for K8s.Discovery"},{"ref":"K8s.Discovery.Driver.html#c:resources/2","title":"K8s.Discovery.Driver.resources/2","type":"callback","doc":"List of Kubernetes APIResourceLists Examples iex&gt; {:ok, conn} = K8s.Conn.lookup(:test) ...&gt; K8s.Discovery.Driver.HTTP.resources(&quot;autoscaling/v1&quot;, conn) {:ok, [ %{ &quot;kind&quot; =&gt; &quot;DaemonSet&quot;, &quot;name&quot; =&gt; &quot;daemonsets&quot; }, %{ &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;name&quot; =&gt; &quot;deployments&quot; }, %{ &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;name&quot; =&gt; &quot;deployments/status&quot; } ]}"},{"ref":"K8s.Discovery.Driver.html#c:resources/3","title":"K8s.Discovery.Driver.resources/3","type":"callback","doc":""},{"ref":"K8s.Discovery.Driver.html#c:versions/1","title":"K8s.Discovery.Driver.versions/1","type":"callback","doc":"List of Kubernetes apiVersions Examples iex&gt; {:ok, conn} = K8s.Conn.lookup(:test) ...&gt; K8s.Discovery.Driver.HTTP.api(conn) {:ok, [&quot;v1&quot;]}"},{"ref":"K8s.Discovery.Driver.html#c:versions/2","title":"K8s.Discovery.Driver.versions/2","type":"callback","doc":""},{"ref":"K8s.Discovery.Driver.html#t:driver_error_t/0","title":"K8s.Discovery.Driver.driver_error_t/0","type":"type","doc":"Errors returned by adapters should return an error tuple with an atom() describing the error or alternatively an &quot;error&quot; struct with more details. Examples {:error, :file_not_found} {:error, %K8s.Discovery.Driver.MyDriver.FileNotFoundError{config: &quot;path-to-file&quot;}}"},{"ref":"K8s.Discovery.Driver.File.html","title":"K8s.Discovery.Driver.File","type":"module","doc":"File Driver for Kubernetes API discovery. This module allows API versions and Resources accessible by the k8s to be defined rather than discovered. This module is primarily used for testing, but can be used if you wish to hard code supported API versions and resources. See ./test/support/discovery/example.json for an example. Examples &quot;Discovering&quot; hard coded resources. iex&gt; K8s.Discovery.Driver.File.resources(&quot;apps/v1&quot;, %K8s.Conn{}, config: &quot;./test/support/discovery/example.json&quot;) [ %{ &quot;kind&quot; =&gt; &quot;DaemonSet&quot;, &quot;name&quot; =&gt; &quot;daemonsets&quot; }, %{ &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;name&quot; =&gt; &quot;deployments&quot; }, %{ &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;name&quot; =&gt; &quot;deployments/status&quot; } ] &quot;Discovering&quot; hard coded versions. iex&gt; K8s.Discovery.Driver.File.versions(%K8s.Conn{}, config: &quot;./test/support/discovery/example.json&quot;) [&quot;v1&quot;, &quot;apps/v1&quot;]"},{"ref":"K8s.Discovery.Driver.HTTP.html","title":"K8s.Discovery.Driver.HTTP","type":"module","doc":"HTTP Driver for Kubernetes API discovery"},{"ref":"K8s.Discovery.ResourceFinder.html","title":"K8s.Discovery.ResourceFinder","type":"module","doc":"Kubernetes API Groups"},{"ref":"K8s.Discovery.ResourceFinder.html#find_resource/3","title":"K8s.Discovery.ResourceFinder.find_resource/3","type":"function","doc":"Finds a resource definition by api version and (name or kind)."},{"ref":"K8s.Discovery.ResourceFinder.html#resource_name_for_kind/3","title":"K8s.Discovery.ResourceFinder.resource_name_for_kind/3","type":"function","doc":"Get the REST resource name for a kubernetes Kind. Since K8s.Operation is abstracted away from a specific cluster, when working with kubernetes resource Maps and specifying &quot;kind&quot; the K8s.Operation.Path module isn&#39;t able to determine the correct path. (It will generate things like /api/v1/Pod instead of api/v1/pods). Also accepts REST resource name in the event they are provided, as it may be known in the event of subresources."},{"ref":"K8s.Discovery.ResourceFinder.html#t:error_t/0","title":"K8s.Discovery.ResourceFinder.error_t/0","type":"type","doc":""},{"ref":"K8s.Middleware.html","title":"K8s.Middleware","type":"module","doc":"Interface for interacting with cluster middleware While middlewares are applied to K8s.Middleware.Requests they are registerd by a cluster name which is an atom. This allows multiple connections to be used (different credentials) with the same middleware stack. Any cluster name that has not been initialized, will automatically have the default stack applied. Examples Using default middleware iex&gt; conn = %K8s.Conn{} ...&gt; req = %K8s.Middlware.Request{} ...&gt; K8s.Middleware.run(req) Adding middlware to a cluster iex&gt; conn = %K8s.Conn{cluster_name: :foo} ...&gt; K8s.Middleware.add(:foo, :request, MyMiddlewareModule) ...&gt; req = %K8s.Middlware.Request{} ...&gt; K8s.Middleware.run(req) Setting/Replacing middleware on a cluster iex&gt; conn = %K8s.Conn{cluster_name: :foo} ...&gt; K8s.Middleware.set(:foo, :request, [MyMiddlewareModule, OtherModule]) ...&gt; req = %K8s.Middlware.Request{} ...&gt; K8s.Middleware.run(req)"},{"ref":"K8s.Middleware.html#run/1","title":"K8s.Middleware.run/1","type":"function","doc":"Applies middlewares registered to a K8s.Cluster to a K8s.Middleware.Request"},{"ref":"K8s.Middleware.html#run/2","title":"K8s.Middleware.run/2","type":"function","doc":""},{"ref":"K8s.Middleware.html#t:type_t/0","title":"K8s.Middleware.type_t/0","type":"type","doc":"Middleware type"},{"ref":"K8s.Middleware.Error.html","title":"K8s.Middleware.Error","type":"module","doc":"Encapsulates middleware process errors"},{"ref":"K8s.Middleware.Error.html#t:t/0","title":"K8s.Middleware.Error.t/0","type":"type","doc":"Middleware processing error middleware middleware module that caused the error requestK8s.Middleware.Request error actual error, can be any() type"},{"ref":"K8s.Middleware.Registry.html","title":"K8s.Middleware.Registry","type":"module","doc":"Cluster middleware registry"},{"ref":"K8s.Middleware.Registry.html#add/3","title":"K8s.Middleware.Registry.add/3","type":"function","doc":"Adds a middleware to the end of the middleware stack"},{"ref":"K8s.Middleware.Registry.html#child_spec/1","title":"K8s.Middleware.Registry.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"K8s.Middleware.Registry.html#defaults/1","title":"K8s.Middleware.Registry.defaults/1","type":"function","doc":""},{"ref":"K8s.Middleware.Registry.html#list/2","title":"K8s.Middleware.Registry.list/2","type":"function","doc":"Returns middleware stack for a cluster and (request or response)"},{"ref":"K8s.Middleware.Registry.html#set/3","title":"K8s.Middleware.Registry.set/3","type":"function","doc":"Sets/replaces the middleware stack"},{"ref":"K8s.Middleware.Registry.html#start_link/1","title":"K8s.Middleware.Registry.start_link/1","type":"function","doc":""},{"ref":"K8s.Middleware.Registry.html#t:stack_t/0","title":"K8s.Middleware.Registry.stack_t/0","type":"type","doc":"List of middlewares"},{"ref":"K8s.Middleware.Request.html","title":"K8s.Middleware.Request","type":"behaviour","doc":"HTTP Request middleware"},{"ref":"K8s.Middleware.Request.html#c:call/1","title":"K8s.Middleware.Request.call/1","type":"callback","doc":"Request middleware callback"},{"ref":"K8s.Middleware.Request.html#t:t/0","title":"K8s.Middleware.Request.t/0","type":"type","doc":"Middleware Request type"},{"ref":"K8s.Middleware.Request.EncodeBody.html","title":"K8s.Middleware.Request.EncodeBody","type":"module","doc":"Naive JSON body encoder. Encodes JSON payloads when given an modifiying HTTP verb, otherwise returns an empty string."},{"ref":"K8s.Middleware.Request.Initialize.html","title":"K8s.Middleware.Request.Initialize","type":"module","doc":"Initializes a request with connection details (header and HTTPoison opts) from K8s.Conn.RequestOptions"},{"ref":"K8s.Operation.html","title":"K8s.Operation","type":"module","doc":"Encapsulates Kubernetes REST API operations."},{"ref":"K8s.Operation.html#build/2","title":"K8s.Operation.build/2","type":"function","doc":"Builds an Operation given a verb and a k8s resource. Examples iex&gt; deploy = %{&quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{&quot;namespace&quot; =&gt; &quot;default&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;}} ...&gt; K8s.Operation.build(:update, deploy) %K8s.Operation{ method: :put, verb: :update, data: %{&quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{&quot;namespace&quot; =&gt; &quot;default&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;}}, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], api_version: &quot;apps/v1&quot;, name: &quot;Deployment&quot; }"},{"ref":"K8s.Operation.html#build/5","title":"K8s.Operation.build/5","type":"function","doc":"Builds an Operation given an verb and a k8s resource info. Note: The name here may be a Kind and not a REST resource name in the event that the operation was built using a map. Use K8s.Discovery.ResourceFinder.resource_name_for_kind/3 to get the correct REST resource name, given a kind. Examples Building a GET deployment operation: iex&gt; K8s.Operation.build(:get, &quot;apps/v1&quot;, :deployment, [namespace: &quot;default&quot;, name: &quot;nginx&quot;]) %K8s.Operation{ method: :get, verb: :get, data: nil, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], api_version: &quot;apps/v1&quot;, name: :deployment } Building a GET deployments/status operation: iex&gt; K8s.Operation.build(:get, &quot;apps/v1&quot;, &quot;deployments/status&quot;, [namespace: &quot;default&quot;, name: &quot;nginx&quot;]) %K8s.Operation{ method: :get, verb: :get, data: nil, path_params: [namespace: &quot;default&quot;, name: &quot;nginx&quot;], api_version: &quot;apps/v1&quot;, name: &quot;deployments/status&quot; }"},{"ref":"K8s.Operation.html#to_path/1","title":"K8s.Operation.to_path/1","type":"function","doc":"Converts a K8s.Operation into a URL path."},{"ref":"K8s.Operation.html#t:name_t/0","title":"K8s.Operation.name_t/0","type":"type","doc":"K8s.Operation name. May be an atom, string, or tuple of {resource, subresource}."},{"ref":"K8s.Operation.html#t:t/0","title":"K8s.Operation.t/0","type":"type","doc":"api_version - API groupVersion, AKA apiVersion name - The name of the REST operation (Kubernets kind/resource/subresource). This is not always the same as the kind key in the data field. e.g: deployments when POSTing, GETting a deployment. data - HTTP request body to submit when applicable. (POST, PUT, PATCH, etc) method - HTTP Method verb - Kubernetes REST API verb (deletecollection, update, create, watch, etc) path_params - Parameters to interpolate into the Kubernetes REST URL name would be deployments in the case of a deployment, but may be deployments/status or deployments/scale for Status and Scale subresources. name and data field examples The following example would update the nginx deployment&#39;s Scale. Note the deployments/scale operation will have a Scale data payload: %K8s.Operation{ method: :put, verb: :update, api_version: &quot;v1&quot;, # api version of the &quot;Scale&quot; kind name: &quot;deployments/scale&quot;, data: %{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Scale&quot;}, # `data` is of kind &quot;Scale&quot; path_params: [name: &quot;nginx&quot;, namespace: &quot;default&quot;] } The following example would update the nginx deployment&#39;s Status. Note the deployments/status operation will have a Deployment data payload: %K8s.Operation{ method: :put, verb: :update, api_version: &quot;apps/v1&quot;, # api version of the &quot;Deployment&quot; kind name: &quot;deployments/status&quot;, data: %{&quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;}, # `data` is of kind &quot;Deployment&quot; path_params: [name: &quot;nginx&quot;, namespace: &quot;default&quot;] }"},{"ref":"K8s.Operation.Path.html","title":"K8s.Operation.Path","type":"module","doc":"Generates Kubernetes REST API Paths"},{"ref":"K8s.Operation.Path.html#build/1","title":"K8s.Operation.Path.build/1","type":"function","doc":"Generates the API path for a K8s.Operation. Examples Generate a path for a cluster scoped resource: iex&gt; resource = K8s.Resource.build(&quot;apps/v1&quot;, &quot;CertificateSigningRequest&quot;, &quot;foo&quot;) ...&gt; operation = %K8s.Operation{ ...&gt; method: :put, ...&gt; verb: :update, ...&gt; data: resource, ...&gt; path_params: [name: &quot;foo&quot;], ...&gt; api_version: &quot;apps/v1&quot;, ...&gt; name: &quot;certificatesigningrequests&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/apis/apps/v1/certificatesigningrequests/foo&quot;} Generate a path for a namespace scoped resource: iex&gt; resource = K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;, &quot;default&quot;, &quot;foo&quot;) ...&gt; operation = %K8s.Operation{ ...&gt; method: :put, ...&gt; verb: :update, ...&gt; data: resource, ...&gt; path_params: [namespace: &quot;default&quot;, name: &quot;foo&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/namespaces/default/pods/foo&quot;} Generate a path for a namespace scoped resource on the collection: (ie create, list) iex&gt; resource = K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;, &quot;default&quot;, &quot;foo&quot;) ...&gt; operation = %K8s.Operation{ ...&gt; method: :post, ...&gt; verb: :create, ...&gt; data: resource, ...&gt; path_params: [namespace: &quot;default&quot;, name: &quot;foo&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/namespaces/default/pods&quot;} Generating a listing path for a namespace: iex&gt; operation = %K8s.Operation{ ...&gt; method: :get, ...&gt; verb: :list, ...&gt; data: nil, ...&gt; path_params: [namespace: &quot;default&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/namespaces/default/pods&quot;} Generating a listing path for a all namespaces: iex&gt; operation = %K8s.Operation{ ...&gt; method: :get, ...&gt; verb: :list_all_namespaces, ...&gt; data: nil, ...&gt; path_params: [namespace: &quot;default&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/pods&quot;} Generating a path for a subresource: iex&gt; operation = %K8s.Operation{ ...&gt; method: :get, ...&gt; verb: :get, ...&gt; data: nil, ...&gt; path_params: [namespace: &quot;default&quot;, name: &quot;foo&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods/status&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/namespaces/default/pods/foo/status&quot;} Deleting a collection: iex&gt; operation = %K8s.Operation{ ...&gt; method: :delete, ...&gt; verb: :deletecollection, ...&gt; data: nil, ...&gt; path_params: [namespace: &quot;default&quot;], ...&gt; api_version: &quot;v1&quot;, ...&gt; name: &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path.build(operation) {:ok, &quot;/api/v1/namespaces/default/pods&quot;}"},{"ref":"K8s.Operation.Path.html#find_params/1","title":"K8s.Operation.Path.find_params/1","type":"function","doc":"Find valid path params in a URL path. Examples iex&gt; K8s.Operation.Path.find_params(&quot;/foo/{name}&quot;) [:name] iex&gt; K8s.Operation.Path.find_params(&quot;/foo/{namespace}/bar/{name}&quot;) [:namespace, :name] iex&gt; K8s.Operation.Path.find_params(&quot;/foo/bar&quot;) []"},{"ref":"K8s.Operation.Path.html#replace_path_vars/2","title":"K8s.Operation.Path.replace_path_vars/2","type":"function","doc":"Replaces path variables with options. Examples iex&gt; K8s.Operation.Path.replace_path_vars(&quot;/foo/{name}&quot;, name: &quot;bar&quot;) &quot;/foo/bar&quot;"},{"ref":"K8s.Resource.html","title":"K8s.Resource","type":"module","doc":"Manifest attribute helpers"},{"ref":"K8s.Resource.html#all_from_file!/2","title":"K8s.Resource.all_from_file!/2","type":"function","doc":"Create a list of resource Maps from a YAML file with multi object annotation. Raises File.Error when the file does not exist. Examples iex&gt; opts = [namespace: &quot;default&quot;, name: &quot;nginx&quot;, image: &quot;nginx:nginx:1.7.9&quot;] ...&gt; K8s.Resource.all_from_file!(&quot;test/support/helm-chart.yaml&quot;, opts) [ %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Namespace&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;default&quot;} }, %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}, &quot;name&quot; =&gt; &quot;nginx-deployment&quot;, &quot;namespace&quot; =&gt; &quot;default&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3, &quot;selector&quot; =&gt; %{&quot;matchLabels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:nginx:1.7.9&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;ports&quot; =&gt; [%{&quot;containerPort&quot; =&gt; 80}] } ] } } } } ]"},{"ref":"K8s.Resource.html#annotation/2","title":"K8s.Resource.annotation/2","type":"function","doc":"See K8s.Resource.FieldAccessors.annotation/2."},{"ref":"K8s.Resource.html#annotations/1","title":"K8s.Resource.annotations/1","type":"function","doc":"See K8s.Resource.FieldAccessors.annotations/1."},{"ref":"K8s.Resource.html#api_version/1","title":"K8s.Resource.api_version/1","type":"function","doc":"See K8s.Resource.FieldAccessors.api_version/1."},{"ref":"K8s.Resource.html#build/2","title":"K8s.Resource.build/2","type":"function","doc":"Helper for building a kubernetes&#39; resource Map Examples iex&gt; K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;) %{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Pod&quot;, &quot;metadata&quot; =&gt; %{}} iex&gt; K8s.Resource.build(&quot;v1&quot;, &quot;Namespace&quot;, &quot;foo&quot;) %{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Namespace&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;foo&quot;}} iex&gt; K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;, &quot;default&quot;, &quot;foo&quot;) %{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Pod&quot;, &quot;metadata&quot; =&gt; %{&quot;namespace&quot; =&gt; &quot;default&quot;, &quot;name&quot; =&gt; &quot;foo&quot;}}"},{"ref":"K8s.Resource.html#build/3","title":"K8s.Resource.build/3","type":"function","doc":""},{"ref":"K8s.Resource.html#build/4","title":"K8s.Resource.build/4","type":"function","doc":""},{"ref":"K8s.Resource.html#build/5","title":"K8s.Resource.build/5","type":"function","doc":""},{"ref":"K8s.Resource.html#cpu/1","title":"K8s.Resource.cpu/1","type":"function","doc":"See K8s.Resource.Utilization.cpu/1."},{"ref":"K8s.Resource.html#from_file!/2","title":"K8s.Resource.from_file!/2","type":"function","doc":"Create a resource Map from a YAML file. Raises File.Error when the file does not exist. Examples iex&gt; opts = [namespace: &quot;default&quot;, name: &quot;nginx&quot;, image: &quot;nginx:nginx:1.7.9&quot;] ...&gt; K8s.Resource.from_file!(&quot;test/support/deployment.yaml&quot;, opts) %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}, &quot;name&quot; =&gt; &quot;nginx-deployment&quot;, &quot;namespace&quot; =&gt; &quot;default&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3, &quot;selector&quot; =&gt; %{&quot;matchLabels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:nginx:1.7.9&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;ports&quot; =&gt; [%{&quot;containerPort&quot; =&gt; 80}] } ] } } } }"},{"ref":"K8s.Resource.html#has_annotation?/2","title":"K8s.Resource.has_annotation?/2","type":"function","doc":"See K8s.Resource.FieldAccessors.has_annotation?/2."},{"ref":"K8s.Resource.html#has_label?/2","title":"K8s.Resource.has_label?/2","type":"function","doc":"See K8s.Resource.FieldAccessors.has_label?/2."},{"ref":"K8s.Resource.html#kind/1","title":"K8s.Resource.kind/1","type":"function","doc":"See K8s.Resource.FieldAccessors.kind/1."},{"ref":"K8s.Resource.html#label/2","title":"K8s.Resource.label/2","type":"function","doc":"See K8s.Resource.FieldAccessors.label/2."},{"ref":"K8s.Resource.html#labels/1","title":"K8s.Resource.labels/1","type":"function","doc":"See K8s.Resource.FieldAccessors.labels/1."},{"ref":"K8s.Resource.html#memory/1","title":"K8s.Resource.memory/1","type":"function","doc":"See K8s.Resource.Utilization.memory/1."},{"ref":"K8s.Resource.html#metadata/1","title":"K8s.Resource.metadata/1","type":"function","doc":"See K8s.Resource.FieldAccessors.metadata/1."},{"ref":"K8s.Resource.html#name/1","title":"K8s.Resource.name/1","type":"function","doc":"See K8s.Resource.FieldAccessors.name/1."},{"ref":"K8s.Resource.html#namespace/1","title":"K8s.Resource.namespace/1","type":"function","doc":"See K8s.Resource.FieldAccessors.namespace/1."},{"ref":"K8s.Resource.FieldAccessors.html","title":"K8s.Resource.FieldAccessors","type":"module","doc":"Helper functions for accessing common fields"},{"ref":"K8s.Resource.FieldAccessors.html#annotation/2","title":"K8s.Resource.FieldAccessors.annotation/2","type":"function","doc":"Returns the value of a k8s resource&#39;s annotation. Examples iex&gt; K8s.Resource.FieldAccessors.annotation(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) &quot;test&quot;"},{"ref":"K8s.Resource.FieldAccessors.html#annotations/1","title":"K8s.Resource.FieldAccessors.annotations/1","type":"function","doc":"Returns the annotations of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors.annotations(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}) %{&quot;env&quot; =&gt; &quot;test&quot;}"},{"ref":"K8s.Resource.FieldAccessors.html#api_version/1","title":"K8s.Resource.FieldAccessors.api_version/1","type":"function","doc":"Returns the apiVersion of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors.api_version(%{&quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;}) &quot;apps/v1&quot;"},{"ref":"K8s.Resource.FieldAccessors.html#has_annotation?/2","title":"K8s.Resource.FieldAccessors.has_annotation?/2","type":"function","doc":"Check if an annotation is present. Examples iex&gt; K8s.Resource.FieldAccessors.has_annotation?(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) true iex&gt; K8s.Resource.FieldAccessors.has_annotation?(%{&quot;metadata&quot; =&gt; %{&quot;annotations&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;foo&quot;) false"},{"ref":"K8s.Resource.FieldAccessors.html#has_label?/2","title":"K8s.Resource.FieldAccessors.has_label?/2","type":"function","doc":"Check if a label is present. Examples iex&gt; K8s.Resource.FieldAccessors.has_label?(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) true iex&gt; K8s.Resource.FieldAccessors.has_label?(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;foo&quot;) false"},{"ref":"K8s.Resource.FieldAccessors.html#kind/1","title":"K8s.Resource.FieldAccessors.kind/1","type":"function","doc":"Returns the kind of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors.kind(%{&quot;kind&quot; =&gt; &quot;Deployment&quot;}) &quot;Deployment&quot;"},{"ref":"K8s.Resource.FieldAccessors.html#label/2","title":"K8s.Resource.FieldAccessors.label/2","type":"function","doc":"Returns the value of a k8s resource&#39;s label. Examples iex&gt; K8s.Resource.FieldAccessors.label(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}, &quot;env&quot;) &quot;test&quot;"},{"ref":"K8s.Resource.FieldAccessors.html#labels/1","title":"K8s.Resource.FieldAccessors.labels/1","type":"function","doc":"Returns the labels of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors.labels(%{&quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;test&quot;}}}) %{&quot;env&quot; =&gt; &quot;test&quot;}"},{"ref":"K8s.Resource.FieldAccessors.html#metadata/1","title":"K8s.Resource.FieldAccessors.metadata/1","type":"function","doc":"Returns the metadata of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors.metadata(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}}) %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}"},{"ref":"K8s.Resource.FieldAccessors.html#name/1","title":"K8s.Resource.FieldAccessors.name/1","type":"function","doc":"Returns the name of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors.name(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}}) &quot;nginx&quot;"},{"ref":"K8s.Resource.FieldAccessors.html#namespace/1","title":"K8s.Resource.FieldAccessors.namespace/1","type":"function","doc":"Returns the namespace of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors.namespace(%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;foo&quot;}}) &quot;foo&quot;"},{"ref":"K8s.Resource.Utilization.html","title":"K8s.Resource.Utilization","type":"module","doc":"Deserializers for CPU and Memory values"},{"ref":"K8s.Resource.Utilization.html#cpu/1","title":"K8s.Resource.Utilization.cpu/1","type":"function","doc":"Deserializes CPU quantity Examples Parses whole values iex&gt; K8s.Resource.Utilization.cpu(&quot;3&quot;) 3 Parses millicpu values iex&gt; K8s.Resource.Utilization.cpu(&quot;500m&quot;) 0.5 Parses decimal values iex&gt; K8s.Resource.Utilization.cpu(&quot;1.5&quot;) 1.5"},{"ref":"K8s.Resource.Utilization.html#memory/1","title":"K8s.Resource.Utilization.memory/1","type":"function","doc":"Deserializes memory quantity Examples Parses whole values iex&gt; K8s.Resource.Utilization.memory(&quot;1000000&quot;) 1000000 Parses decimal values iex&gt; K8s.Resource.Utilization.memory(&quot;10.75&quot;) 10.75 Parses decimalSI values iex&gt; K8s.Resource.Utilization.memory(&quot;10M&quot;) 10000000 Parses binarySI suffixes iex&gt; K8s.Resource.Utilization.memory(&quot;50Mi&quot;) 52428800 Returns the numeric value when the suffix is unrecognized iex&gt; K8s.Resource.Utilization.memory(&quot;50Foo&quot;) 50"},{"ref":"K8s.Selector.html","title":"K8s.Selector","type":"module","doc":"Builds label selectors and field selectors for K8s.Operations Examples Parse from a YAML map iex&gt; deployment = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot;, ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;tier&quot; =&gt; &quot;backend&quot; ...&gt; } ...&gt; }, ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; }, ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot;, ...&gt; &quot;tier&quot; =&gt; &quot;backend&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Selector.parse(deployment) %K8s.Selector{match_labels: %{&quot;app&quot; =&gt; &quot;nginx&quot;}} Provides a composable interface for building label selectors iex&gt; {&quot;component&quot;, &quot;redis&quot;} ...&gt; |&gt; K8s.Selector.label() ...&gt; |&gt; K8s.Selector.label_in({&quot;tier&quot;, &quot;cache&quot;}) ...&gt; |&gt; K8s.Selector.label_not_in({&quot;environment&quot;, &quot;dev&quot;}) ...&gt; |&gt; K8s.Selector.label_exists(&quot;foo&quot;) ...&gt; |&gt; K8s.Selector.label_does_not_exist(&quot;bar&quot;) %K8s.Selector{ match_labels: %{&quot;component&quot; =&gt; &quot;redis&quot;}, match_expressions: [ %{&quot;key&quot; =&gt; &quot;tier&quot;, &quot;operator&quot; =&gt; &quot;In&quot;, &quot;values&quot; =&gt; [&quot;cache&quot;]}, %{&quot;key&quot; =&gt; &quot;environment&quot;, &quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;values&quot; =&gt; [&quot;dev&quot;]}, %{&quot;key&quot; =&gt; &quot;foo&quot;, &quot;operator&quot; =&gt; &quot;Exists&quot;}, %{&quot;key&quot; =&gt; &quot;bar&quot;, &quot;operator&quot; =&gt; &quot;DoesNotExist&quot;} ] } Provides a composable interface for adding selectors to K8s.Operations. iex&gt; K8s.Client.get(&quot;v1&quot;, :pods) ...&gt; |&gt; K8s.Selector.label({&quot;app&quot;, &quot;nginx&quot;}) ...&gt; |&gt; K8s.Selector.label_in({&quot;environment&quot;, [&quot;qa&quot;, &quot;prod&quot;]}) %K8s.Operation{data: nil, api_version: &quot;v1&quot;, label_selector: %K8s.Selector{match_expressions: [%{&quot;key&quot; =&gt; &quot;environment&quot;, &quot;operator&quot; =&gt; &quot;In&quot;, &quot;values&quot; =&gt; [&quot;qa&quot;, &quot;prod&quot;]}], match_labels: %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, method: :get, name: :pods, path_params: [], verb: :get}"},{"ref":"K8s.Selector.html#label/1","title":"K8s.Selector.label/1","type":"function","doc":"matchLabels helper that creates a composable K8s.Selector. Examples iex&gt; K8s.Selector.label({&quot;component&quot;, &quot;redis&quot;}) %K8s.Selector{match_labels: %{&quot;component&quot; =&gt; &quot;redis&quot;}}"},{"ref":"K8s.Selector.html#label/2","title":"K8s.Selector.label/2","type":"function","doc":"matchLabels helper that creates a composable K8s.Selector. Examples iex&gt; selector = K8s.Selector.label({&quot;component&quot;, &quot;redis&quot;}) ...&gt; K8s.Selector.label(selector, {&quot;environment&quot;, &quot;dev&quot;}) %K8s.Selector{match_labels: %{&quot;component&quot; =&gt; &quot;redis&quot;, &quot;environment&quot; =&gt; &quot;dev&quot;}}"},{"ref":"K8s.Selector.html#label_does_not_exist/1","title":"K8s.Selector.label_does_not_exist/1","type":"function","doc":"DoesNotExist expression helper that creates a composable K8s.Selector. Examples iex&gt; K8s.Selector.label_does_not_exist(&quot;environment&quot;) %K8s.Selector{match_expressions: [%{&quot;key&quot; =&gt; &quot;environment&quot;, &quot;operator&quot; =&gt; &quot;DoesNotExist&quot;}]}"},{"ref":"K8s.Selector.html#label_does_not_exist/2","title":"K8s.Selector.label_does_not_exist/2","type":"function","doc":""},{"ref":"K8s.Selector.html#label_exists/1","title":"K8s.Selector.label_exists/1","type":"function","doc":"Exists expression helper that creates a composable K8s.Selector. Examples iex&gt; K8s.Selector.label_exists(&quot;environment&quot;) %K8s.Selector{match_expressions: [%{&quot;key&quot; =&gt; &quot;environment&quot;, &quot;operator&quot; =&gt; &quot;Exists&quot;}]}"},{"ref":"K8s.Selector.html#label_exists/2","title":"K8s.Selector.label_exists/2","type":"function","doc":""},{"ref":"K8s.Selector.html#label_in/1","title":"K8s.Selector.label_in/1","type":"function","doc":"In expression helper that creates a composable K8s.Selector. Examples iex&gt; K8s.Selector.label_in({&quot;component&quot;, &quot;redis&quot;}) %K8s.Selector{match_expressions: [%{&quot;key&quot; =&gt; &quot;component&quot;, &quot;operator&quot; =&gt; &quot;In&quot;, &quot;values&quot; =&gt; [&quot;redis&quot;]}]}"},{"ref":"K8s.Selector.html#label_in/2","title":"K8s.Selector.label_in/2","type":"function","doc":""},{"ref":"K8s.Selector.html#label_not_in/1","title":"K8s.Selector.label_not_in/1","type":"function","doc":"NotIn expression helper that creates a composable K8s.Selector. Examples iex&gt; K8s.Selector.label_not_in({&quot;component&quot;, &quot;redis&quot;}) %K8s.Selector{match_expressions: [%{&quot;key&quot; =&gt; &quot;component&quot;, &quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;values&quot; =&gt; [&quot;redis&quot;]}]}"},{"ref":"K8s.Selector.html#label_not_in/2","title":"K8s.Selector.label_not_in/2","type":"function","doc":""},{"ref":"K8s.Selector.html#match_expression?/2","title":"K8s.Selector.match_expression?/2","type":"function","doc":"Checks whether a resource matches a single selector matchExpressions Examples When an In expression matches iex&gt; resource = %{&quot;kind&quot; =&gt; &quot;Node&quot;, &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;prod&quot;}}} ...&gt; expr = %{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;env&quot;, &quot;values&quot; =&gt; [&quot;prod&quot;, &quot;qa&quot;]} ...&gt; K8s.Selector.match_expression?(resource, expr) true When an In expression doesnt match iex&gt; resource = %{&quot;kind&quot; =&gt; &quot;Node&quot;, &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;dev&quot;}}} ...&gt; expr = %{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;env&quot;, &quot;values&quot; =&gt; [&quot;prod&quot;, &quot;qa&quot;]} ...&gt; K8s.Selector.match_expression?(resource, expr) false When an NotIn expression matches iex&gt; resource = %{&quot;kind&quot; =&gt; &quot;Node&quot;, &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;dev&quot;}}} ...&gt; expr = %{&quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;key&quot; =&gt; &quot;env&quot;, &quot;values&quot; =&gt; [&quot;prod&quot;]} ...&gt; K8s.Selector.match_expression?(resource, expr) true When an NotIn expression doesnt match iex&gt; resource = %{&quot;kind&quot; =&gt; &quot;Node&quot;, &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;dev&quot;}}} ...&gt; expr = %{&quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;key&quot; =&gt; &quot;env&quot;, &quot;values&quot; =&gt; [&quot;dev&quot;]} ...&gt; K8s.Selector.match_expression?(resource, expr) false When an Exists expression matches iex&gt; resource = %{&quot;kind&quot; =&gt; &quot;Node&quot;, &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;dev&quot;}}} ...&gt; expr = %{&quot;operator&quot; =&gt; &quot;Exists&quot;, &quot;key&quot; =&gt; &quot;env&quot;} ...&gt; K8s.Selector.match_expression?(resource, expr) true When an Exists expression doesnt match iex&gt; resource = %{&quot;kind&quot; =&gt; &quot;Node&quot;, &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;dev&quot;}}} ...&gt; expr = %{&quot;operator&quot; =&gt; &quot;Exists&quot;, &quot;key&quot; =&gt; &quot;tier&quot;} ...&gt; K8s.Selector.match_expression?(resource, expr) false When an DoesNotExist expression matches iex&gt; resource = %{&quot;kind&quot; =&gt; &quot;Node&quot;, &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;dev&quot;}}} ...&gt; expr = %{&quot;operator&quot; =&gt; &quot;DoesNotExist&quot;, &quot;key&quot; =&gt; &quot;tier&quot;} ...&gt; K8s.Selector.match_expression?(resource, expr) true When an DoesNotExist expression doesnt match iex&gt; resource = %{&quot;kind&quot; =&gt; &quot;Node&quot;, &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;dev&quot;}}} ...&gt; expr = %{&quot;operator&quot; =&gt; &quot;DoesNotExist&quot;, &quot;key&quot; =&gt; &quot;env&quot;} ...&gt; K8s.Selector.match_expression?(resource, expr) false"},{"ref":"K8s.Selector.html#match_expressions?/2","title":"K8s.Selector.match_expressions?/2","type":"function","doc":"Checks if a K8s.Resource matches all matchExpressions using a logical AND Examples Accepts K8s.Selectors: iex&gt; resource = %{&quot;kind&quot; =&gt; &quot;Node&quot;, &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;prod&quot;, &quot;tier&quot; =&gt; &quot;frontend&quot;}}} ...&gt; expr1 = %{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;env&quot;, &quot;values&quot; =&gt; [&quot;prod&quot;, &quot;qa&quot;]} ...&gt; expr2 = %{&quot;operator&quot; =&gt; &quot;Exists&quot;, &quot;key&quot; =&gt; &quot;tier&quot;} ...&gt; selector = %K8s.Selector{match_expressions: [expr1, expr2]} ...&gt; K8s.Selector.match_expressions?(resource, selector) true Accepts maps: iex&gt; resource = %{&quot;kind&quot; =&gt; &quot;Node&quot;, &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;prod&quot;, &quot;tier&quot; =&gt; &quot;frontend&quot;}}} ...&gt; expr1 = %{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;env&quot;, &quot;values&quot; =&gt; [&quot;prod&quot;, &quot;qa&quot;]} ...&gt; expr2 = %{&quot;operator&quot; =&gt; &quot;Exists&quot;, &quot;key&quot; =&gt; &quot;tier&quot;} ...&gt; K8s.Selector.match_expressions?(resource, [expr1, expr2]) true Returns false when not matching all expressions: iex&gt; resource = %{&quot;kind&quot; =&gt; &quot;Node&quot;, &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;env&quot; =&gt; &quot;prod&quot;, &quot;tier&quot; =&gt; &quot;frontend&quot;}}} ...&gt; expr1 = %{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;env&quot;, &quot;values&quot; =&gt; [&quot;prod&quot;, &quot;qa&quot;]} ...&gt; expr2 = %{&quot;operator&quot; =&gt; &quot;Exists&quot;, &quot;key&quot; =&gt; &quot;foo&quot;} ...&gt; K8s.Selector.match_expressions?(resource, [expr1, expr2]) false"},{"ref":"K8s.Selector.html#match_label?/3","title":"K8s.Selector.match_label?/3","type":"function","doc":"Checks if a K8s.Resource matches a single label"},{"ref":"K8s.Selector.html#match_labels?/2","title":"K8s.Selector.match_labels?/2","type":"function","doc":"Checks if a K8s.Resource matches all matchLabels using a logcal AND Examples Accepts K8s.Selectors: iex&gt; labels = %{&quot;env&quot; =&gt; &quot;prod&quot;, &quot;tier&quot; =&gt; &quot;frontend&quot;} ...&gt; selector = %K8s.Selector{match_labels: labels} ...&gt; resource = K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;, &quot;default&quot;, &quot;test&quot;, labels) ...&gt; K8s.Selector.match_labels?(resource, selector) true Accepts maps: iex&gt; labels = %{&quot;env&quot; =&gt; &quot;prod&quot;, &quot;tier&quot; =&gt; &quot;frontend&quot;} ...&gt; resource = K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;, &quot;default&quot;, &quot;test&quot;, labels) ...&gt; K8s.Selector.match_labels?(resource, labels) true Returns false when not matching all labels: iex&gt; not_a_match = %{&quot;env&quot; =&gt; &quot;prod&quot;, &quot;tier&quot; =&gt; &quot;frontend&quot;, &quot;nope&quot; =&gt; &quot;not-a-match&quot;} ...&gt; resource = K8s.Resource.build(&quot;v1&quot;, &quot;Pod&quot;, &quot;default&quot;, &quot;test&quot;, %{&quot;env&quot; =&gt; &quot;prod&quot;, &quot;tier&quot; =&gt; &quot;frontend&quot;}) ...&gt; K8s.Selector.match_labels?(resource, not_a_match) false"},{"ref":"K8s.Selector.html#parse/1","title":"K8s.Selector.parse/1","type":"function","doc":"Parses a &quot;selector&quot; map of &quot;matchLabels&quot; and &quot;matchExpressions&quot; Examples iex&gt; selector = %{ ...&gt; &quot;matchLabels&quot; =&gt; %{&quot;component&quot; =&gt; &quot;redis&quot;}, ...&gt; &quot;matchExpressions&quot; =&gt; [ ...&gt; %{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;tier&quot;, &quot;values&quot; =&gt; [&quot;cache&quot;]}, ...&gt; %{&quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;key&quot; =&gt; &quot;environment&quot;, &quot;values&quot; =&gt; [&quot;dev&quot;]} ...&gt; ] ...&gt; } ...&gt; K8s.Selector.parse(selector) %K8s.Selector{match_labels: %{&quot;component&quot; =&gt; &quot;redis&quot;}, match_expressions: [%{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;tier&quot;, &quot;values&quot; =&gt; [&quot;cache&quot;]},%{&quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;key&quot; =&gt; &quot;environment&quot;, &quot;values&quot; =&gt; [&quot;dev&quot;]}]}"},{"ref":"K8s.Selector.html#serialize_match_expressions/1","title":"K8s.Selector.serialize_match_expressions/1","type":"function","doc":"Returns a labelSelector query string value for a set of label expressions. For != matches, use a NotIn set-based expression. Examples Builds a query string for In expressions (kubectl get pods -l &#39;environment in (production,qa),tier in (frontend)): iex&gt; expressions = [ ...&gt; %{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;environment&quot;, &quot;values&quot; =&gt; [&quot;production&quot;, &quot;qa&quot;]}, ...&gt; %{&quot;operator&quot; =&gt; &quot;In&quot;, &quot;key&quot; =&gt; &quot;tier&quot;, &quot;values&quot; =&gt; [&quot;frontend&quot;]}, ...&gt; ] ...&gt; K8s.Selector.serialize_match_expressions(expressions) [&quot;environment in (production,qa)&quot;, &quot;tier in (frontend)&quot;] Builds a query string for NotIn expressions (kubectl get pods -l &#39;environment notin (frontend)): iex&gt; expressions = [ ...&gt; %{&quot;operator&quot; =&gt; &quot;NotIn&quot;, &quot;key&quot; =&gt; &quot;environment&quot;, &quot;values&quot; =&gt; [&quot;frontend&quot;]} ...&gt; ] ...&gt; K8s.Selector.serialize_match_expressions(expressions) [&quot;environment notin (frontend)&quot;] Builds a query string for Exists expressions (kubectl get pods -l &#39;environment&#39;): iex&gt; expressions = [ ...&gt; %{&quot;operator&quot; =&gt; &quot;Exists&quot;, &quot;key&quot; =&gt; &quot;environment&quot;} ...&gt; ] ...&gt; K8s.Selector.serialize_match_expressions(expressions) [&quot;environment&quot;] Builds a query string for DoesNotExist expressions (kubectl get pods -l &#39;!environment&#39;): iex&gt; expressions = [ ...&gt; %{&quot;operator&quot; =&gt; &quot;DoesNotExist&quot;, &quot;key&quot; =&gt; &quot;environment&quot;} ...&gt; ] ...&gt; K8s.Selector.serialize_match_expressions(expressions) [&quot;!environment&quot;]"},{"ref":"K8s.Selector.html#serialize_match_labels/1","title":"K8s.Selector.serialize_match_labels/1","type":"function","doc":"Returns a labelSelector query string value for a set of label matches. Examples Builds a query string for a single label (kubectl get pods -l environment=production): iex&gt; K8s.Selector.serialize_match_labels(%{&quot;environment&quot; =&gt; &quot;prod&quot;}) [&quot;environment=prod&quot;] Builds a query string for multiple labels (kubectl get pods -l environment=production,tier=frontend): iex&gt; K8s.Selector.serialize_match_labels(%{&quot;environment&quot; =&gt; &quot;prod&quot;, &quot;tier&quot; =&gt; &quot;frontend&quot;}) [&quot;environment=prod&quot;, &quot;tier=frontend&quot;]"},{"ref":"K8s.Selector.html#to_s/1","title":"K8s.Selector.to_s/1","type":"function","doc":"Serializes a K8s.Selector to a labelSelector query string. Examples iex&gt; selector = K8s.Selector.label({&quot;component&quot;, &quot;redis&quot;}) ...&gt; K8s.Selector.to_s(selector) &quot;component=redis&quot;"},{"ref":"K8s.Selector.html#t:selector_or_operation_t/0","title":"K8s.Selector.selector_or_operation_t/0","type":"type","doc":""},{"ref":"K8s.Selector.html#t:t/0","title":"K8s.Selector.t/0","type":"type","doc":""},{"ref":"K8s.Sys.Event.html","title":"K8s.Sys.Event","type":"module","doc":"K8s.Sys.Event is a thin wrapper around :telemetry. All events will be prefixed with k8s. The following events are emitted: [:k8s, :cluster, :registered] [:k8s, :http, :request, :failed] [:k8s, :http, :request, :succeeded] To access this list programmatically use events/0. If set, default metadata will be applied to all events. See: metadata/0"},{"ref":"K8s.Sys.Event.html#cluster_registered/2","title":"K8s.Sys.Event.cluster_registered/2","type":"function","doc":"When a cluster is successfully registered"},{"ref":"K8s.Sys.Event.html#events/0","title":"K8s.Sys.Event.events/0","type":"function","doc":"Returns a list of all events emitted by this module: [:k8s, :cluster, :registered] [:k8s, :http, :request, :failed] [:k8s, :http, :request, :succeeded] Great for use with :telemetry.attach_many/4"},{"ref":"K8s.Sys.Event.html#http_request_failed/2","title":"K8s.Sys.Event.http_request_failed/2","type":"function","doc":"K8s.Client.HTTPProvider request failed"},{"ref":"K8s.Sys.Event.html#http_request_succeeded/2","title":"K8s.Sys.Event.http_request_succeeded/2","type":"function","doc":"K8s.Client.HTTPProvider request succeeded"},{"ref":"K8s.Sys.Event.html#metadata/0","title":"K8s.Sys.Event.metadata/0","type":"function","doc":"Default metadata added to all events. Defaults: %{}"},{"ref":"K8s.Sys.Event.html#metadata/1","title":"K8s.Sys.Event.metadata/1","type":"function","doc":"Merges metadata with defaults"},{"ref":"K8s.Sys.Event.html#name/0","title":"K8s.Sys.Event.name/0","type":"function","doc":"The instrumenter name"},{"ref":"K8s.Sys.Logger.html","title":"K8s.Sys.Logger","type":"module","doc":"Attaches telemetry events to the Elixir Logger"},{"ref":"K8s.Sys.Logger.html#attach/0","title":"K8s.Sys.Logger.attach/0","type":"function","doc":"Attaches telemetry events to the Elixir Logger"},{"ref":"K8s.Version.html","title":"K8s.Version","type":"module","doc":"Kubernetes API Versioning"},{"ref":"K8s.Version.html#alpha/1","title":"K8s.Version.alpha/1","type":"function","doc":"Returns only alpha versions Examples iex&gt; K8s.Version.alpha([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}]"},{"ref":"K8s.Version.html#beta/1","title":"K8s.Version.beta/1","type":"function","doc":"Returns only beta versions Examples iex&gt; K8s.Version.beta([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 2, minor: &quot;beta&quot;, patch: 1}]"},{"ref":"K8s.Version.html#edge/1","title":"K8s.Version.edge/1","type":"function","doc":"Retuns all non-stable versions Examples iex&gt; K8s.Version.edge([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}, %K8s.Version{major: 2, minor: &quot;beta&quot;, patch: 1}]"},{"ref":"K8s.Version.html#parse/1","title":"K8s.Version.parse/1","type":"function","doc":"Parses a Kubernetes API version into a K8s.Version struct Examples iex&gt; K8s.Version.parse(&quot;v1&quot;) %K8s.Version{major: 1, minor: &quot;stable&quot;, patch: nil} iex&gt; K8s.Version.parse(&quot;v1beta2&quot;) %K8s.Version{major: 1, minor: &quot;beta&quot;, patch: 2} iex&gt; K8s.Version.parse(&quot;v1alpha1&quot;) %K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}"},{"ref":"K8s.Version.html#recommended/1","title":"K8s.Version.recommended/1","type":"function","doc":"Returns the recommended version from a list of versions. It will return the most stable version if any, otherwise the newest &quot;edge&quot; version. Examples iex&gt; K8s.Version.recommended([&quot;v1beta1&quot;, &quot;v1&quot;, &quot;v2&quot;]) &quot;v2&quot; iex&gt; K8s.Version.recommended([&quot;v1beta1&quot;, &quot;v1&quot;]) &quot;v1&quot; iex&gt; K8s.Version.recommended([&quot;v1beta2&quot;, &quot;v1beta1&quot;]) &quot;v1beta2&quot; iex&gt; K8s.Version.recommended([&quot;v1alpha1&quot;, &quot;v1alpha2&quot;, &quot;v1beta1&quot;]) &quot;v1beta1&quot;"},{"ref":"K8s.Version.html#serialize/1","title":"K8s.Version.serialize/1","type":"function","doc":"Returns only stable versions Examples iex&gt; K8s.Version.serialize(%K8s.Version{major: 1, minor: &quot;stable&quot;, patch: nil}) &quot;v1&quot; iex&gt; K8s.Version.serialize(%K8s.Version{major: 1, minor: &quot;beta&quot;, patch: 1}) &quot;v1beta1&quot; iex&gt; K8s.Version.serialize(%K8s.Version{major: 1, minor: &quot;alpha&quot;, patch: 1}) &quot;v1alpha1&quot;"},{"ref":"K8s.Version.html#sort/1","title":"K8s.Version.sort/1","type":"function","doc":"Sorts a list of K8s.Versions Examples iex&gt; raw_versions = Enum.shuffle([&quot;v1&quot;, &quot;v2beta1&quot;, &quot;v2&quot;, &quot;v1alpha1&quot;, &quot;v1alpha2&quot;]) iex&gt; versions = raw_versions |&gt; Enum.map(&amp;(K8s.Version.parse(&amp;1))) iex&gt; sorted_versions = versions |&gt; K8s.Version.sort() iex&gt; sorted_versions |&gt; Enum.map(&amp;(K8s.Version.serialize(&amp;1))) [&quot;v2&quot;, &quot;v1&quot;, &quot;v2beta1&quot;, &quot;v1alpha2&quot;, &quot;v1alpha1&quot;]"},{"ref":"K8s.Version.html#stable/1","title":"K8s.Version.stable/1","type":"function","doc":"Returns only stable versions Examples iex&gt; K8s.Version.stable([&quot;v1alpha1&quot;, &quot;v1&quot;, &quot;v2beta1&quot;]) [%K8s.Version{major: 1, minor: &quot;stable&quot;, patch: nil}]"},{"ref":"K8s.Version.html#t:t/0","title":"K8s.Version.t/0","type":"type","doc":""},{"ref":"readme.html","title":"K8s","type":"extras","doc":"K8s K8s - Kubernetes API Client for Elixir"},{"ref":"readme.html#features","title":"K8s - Features","type":"extras","doc":"A client API for humans 👩🏼🧑👩🏻👩🏽👩🏾🧑🏻🧑🏽🧑🧑🏾👨🏼👨🏾👨🏿 🔮 Kubernetes resources, groups, and CRDs are autodiscovered at boot time. No swagger file to include or override. Client supports standard HTTP calls, async batches, wait on status ⏲️, and watchers 👀 ⚙️ HTTP Request middleware Multiple clusters ⚓ ⚓ ⚓ 🔐 Multiple authentication credentials 🤖 serviceaccount token 📜 certificate auth-provider Pluggable auth providers! 🆗 Tested against Kubernetes versions 1.10+ and master 🛠️ CRD support 📈 Integrated with :telemetry ℹ️ Kubernetes resource and version helper functions 🧰 Kube config file parsing 🏎️ Macro free; fast compile &amp; fast startup"},{"ref":"readme.html#installation","title":"K8s - Installation","type":"extras","doc":"The package can be installed by adding k8s to your list of dependencies in mix.exs: def deps do [ {:k8s, &quot;~&gt; 0.5&quot;} ] end"},{"ref":"readme.html#usage","title":"K8s - Usage","type":"extras","doc":"Check out the Usage Guide for in-depth examples. Most functions are also written using doctests. K8s.Client doctests K8s.Conn doctests K8s.Resource doctests K8s.Version doctests"},{"ref":"readme.html#testing-k8s-operations-in-your-application","title":"K8s - Testing K8s operations in your application","type":"extras","doc":"K8s ships with a K8s.Client.DynamicHTTPProvider for stubbing HTTP responses to kubernetes API requests. This provider is used throughout the test suite for mocking HTTP responses. defmodule MyApp.ResourceTest do use ExUnit.Case, async: true defmodule K8sMock do @base_url &quot;https://localhost:6443&quot; @namespaces_url @base_url &lt;&gt; &quot;/api/v1/namespaces&quot; def request(:get, @namespaces_url, _, _, _) do namespaces = [%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;default&quot;}}] body = Jason.encode!(namespaces) {:ok, %HTTPoison.Response{status_code: 200, body: body}} end end setup do DynamicHTTPProvider.register(self(), __MODULE__.K8sMock) end test &quot;gets namespaces&quot; do conn = %K8s.Conn{} # set up your conn operation = K8s.Client.get(&quot;v1&quot;, :namespaces) assert {:ok, namespaces} = K8s.Client.run(operation, conn) assert namespaces == [%{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;default&quot;}}] end end To see advanced examples of usage, check out these examples in the test suite: client/runner/base client/runner/stream client/runner/watch discovery"},{"ref":"readme.html#contributing","title":"K8s - Contributing","type":"extras","doc":"Adding support for a new version of kubernetes Download the swagger spec for the new version. k8s doesn&#39;t use swagger to define the API, but it is used to drive property tests. export NEW_VERSION_NUMBER=1.1n make get/${NEW_VERSION_NUMBER} make test/${NEW_VERSION_NUMBER} Mock discovery responses exist to simulate runtime API discovery using the FileDriver If new resources or APIs were added to kubernetes in the new version you will may see: unsupported_resource. Unsupported Resource errors This error occurs when a new resource type is added to an existing API, similar to above you will need to add the resource to the list of resources. The following config is missing runtimeclasses as a resource. { &quot;groupVersion&quot;: &quot;node.k8s.io/v1beta1&quot;, &quot;kind&quot;: &quot;APIResourceList&quot;, &quot;resources&quot;: [ { &quot;kind&quot;: &quot;Node&quot;, &quot;name&quot;: &quot;nodes&quot;, &quot;namespaced&quot;: false, &quot;singularName&quot;: &quot;&quot;, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] } ] }, After mocking: { &quot;groupVersion&quot;: &quot;node.k8s.io/v1beta1&quot;, &quot;kind&quot;: &quot;APIResourceList&quot;, &quot;resources&quot;: [ { &quot;kind&quot;: &quot;Node&quot;, &quot;name&quot;: &quot;nodes&quot;, &quot;namespaced&quot;: false, &quot;singularName&quot;: &quot;&quot;, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] }, { &quot;kind&quot;: &quot;RuntimeClass&quot;, &quot;name&quot;: &quot;runtimeclasses&quot;, &quot;namespaced&quot;: false, &quot;singularName&quot;: &quot;&quot;, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] } ] },"},{"ref":"usage.html","title":"Usage","type":"extras","doc":"Usage Connections (K8s.Conn) Operations (K8s.Operation) Discovery (K8s.Discovery) Middleware (K8s.Middleware) Authentication (K8s.Conn.Auth)"},{"ref":"connections.html","title":"Server Connections and Configuration","type":"extras","doc":"Server Connections and Configuration A connection (K8s.Conn) is the encapsulation of cluster information and authentication. They can be registered at compile time, runtime via environment variables, and runtime manually by creating a struct. K8s.Conns can be registered via Mix Config (config.exs) or environment variables. K8s.Conns may also be built programmaticaly. Multiple clusters can be registered via config or at runtime. See K8s.Conn.Config."},{"ref":"connections.html#registering-connections-at-compile-time-config-exs","title":"Server Connections and Configuration - Registering Connections at Compile Time (config.exs)","type":"extras","doc":"Connections are named (the key in the clusters map below). The name is only important when registering K8s.Middleware for specific server connections. Adding a cluster named :default using ~/.kube/config. Defaults to current-context of the kube config file. config :k8s, clusters: %{ default: %{ conn: &quot;~/.kube/config&quot; } } Multiple clusters connections can be configured by adding additional keys to the clusters map. Connections can later be looked up using K8s.Conn.lookup/1. The lookup/1 function can only find connections that are registered via a Mix config or environment variables. {:ok, conn} = K8s.Conn.lookup(:default) Alternatively additional connection options can be specified to use other contexts, users, and clusters. Using a different context: config :k8s, clusters: %{ default: %{ conn: &quot;~/.kube/config&quot; conn_opts: [context: &quot;other-context&quot;] } } Setting cluster and user explicitly: config :k8s, clusters: %{ default: %{ conn: &quot;~/.kube/config&quot; conn_opts: [user: &quot;some-user&quot;, cluster: &quot;prod-cluster&quot;] } } Using a pod&#39;s service account (pod.spec.serviceAccountName): A cluster name with a blank configuration will default to using the pod&#39;s service account. config :k8s, clusters: %{ default: %{} }"},{"ref":"connections.html#registering-connections-with-environment-variables","title":"Server Connections and Configuration - Registering Connections with Environment Variables","type":"extras","doc":"Multiple clusters can be registered via environment variables. Keep in mind that under the hood, k8s uses Kubernetes config files and service account directories. Environment Variable Prefixes: Prefixes are used to configure multiple connections. The word following the last underscore _ in the prefix will be the name of the connection. This name will be atomized. K8S_CLUSTER_CONF_SA_ - boolean enables authentication to the k8s API with the pods spec.serviceAccount. K8S_CLUSTER_CONF_PATH_ - string absolute path to the kube config file. K8S_CLUSTER_CONF_CONTEXT_ string which context to use in the kube config file. Examples: Configure access to a cluster named us_central to use the pod&#39;s service account: export K8S_CLUSTER_CONF_SA_us_central=true Set the path to a kubeconfig file and the context to use for us_east: export K8S_CLUSTER_CONF_PATH_us_east=&quot;east.yaml&quot; export K8S_CLUSTER_CONF_CONTEXT_us_east=&quot;east&quot; Register multiple clusters: export K8S_CLUSTER_CONF_SA_us_central=true export K8S_CLUSTER_CONF_PATH_us_east=&quot;east.yaml&quot; export K8S_CLUSTER_CONF_CONTEXT_us_east=&quot;east&quot; export K8S_CLUSTER_CONF_PATH_us_west=&quot;west.yaml&quot; export K8S_CLUSTER_CONF_CONTEXT_us_west=&quot;west&quot;"},{"ref":"connections.html#building-connections-programmatically","title":"Server Connections and Configuration - Building connections programmatically","type":"extras","doc":"There are a few helper functions for creating K8s.Conns, but they can also be created by using a struct. Using K8s.Conn.from_file/2: Using a kube config file will set the cluster name to the name of the cluster in the kube config. conn = K8s.Conn.from_file(&quot;/path/to/kube/config&quot;, context: &quot;docker-for-desktop&quot;) Using K8s.Conn.from_service_account/2: A cluster name must be provided when creating connections from service account directories. If a path isn&#39;t provided for the service account, the default path is used /var/run/secrets/kubernetes.io/serviceaccount. conn = K8s.Conn.from_service_account(:cluster_name_here) Optionally the path can be specified: conn = K8s.Conn.from_service_account(:cluster_name_here, &quot;/path/to/service/account/directory&quot;) Creating a K8s.Conn struct manually: For the use case of having an unbound number of connections (a multi-tenant K8s service) connections can be manually created. %K8s.Conn{ cluster_name: :default, user_name: &quot;optional-user-name-in-kubeconfig&quot;, url: &quot;https://ip-address-of-cluster&quot;, ca_cert: K8s.Conn.PKI.cert_from_map(cluster, base_path), auth: %K8s.Conn.Auth{}, insecure_skip_tls_verify: false, discovery_driver: K8s.Discovery.Driver.HTTP, discovery_opts: [cache: true] } See authentication and discovery for details on these options."},{"ref":"operations.html","title":"HTTP Operations (K8s.Operation)","type":"extras","doc":"HTTP Operations (K8s.Operation) K8s.Operations are Kubernetes REST operations. They encapsulate all the details of an HTTP request except the server to perform them against. Many more client examples exist in the K8s.Client docs."},{"ref":"operations.html#creating-a-deployment-from-a-map","title":"HTTP Operations (K8s.Operation) - Creating a Deployment from a Map","type":"extras","doc":"resource = %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot;, &quot;kind&quot; =&gt; &quot;Deployment&quot;, &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}, &quot;name&quot; =&gt; &quot;nginx-deployment&quot;, &quot;namespace&quot; =&gt; &quot;default&quot; }, &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3, &quot;selector&quot; =&gt; %{&quot;matchLabels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{&quot;labels&quot; =&gt; %{&quot;app&quot; =&gt; &quot;nginx&quot;}}, &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:1.7.9&quot;, &quot;name&quot; =&gt; &quot;nginx&quot;, &quot;ports&quot; =&gt; [%{&quot;containerPort&quot; =&gt; 80}] } ] } } } } operation = K8s.Client.create(resource) {:ok, conn} = K8s.Conn.lookup(:my_registered_connection_name) {:ok, response} = K8s.Client.run(operation, conn)"},{"ref":"operations.html#creating-a-deployment-from-a-yaml-file","title":"HTTP Operations (K8s.Operation) - Creating a Deployment from a YAML File","type":"extras","doc":"K8s.Resource provides YAML resource parsing and interpolation support as well as a few helper functions for accessing common Kubernetes resource fields. Given the YAML file priv/deployment.yaml: apiVersion: apps/v1 kind: Deployment metadata: name: &lt;%= name %&gt;-deployment namespace: &lt;%= namespace %&gt; labels: app: &lt;%= name %&gt; spec: replicas: 3 selector: matchLabels: app: &lt;%= name %&gt; template: metadata: labels: app: &lt;%= name %&gt; spec: containers: - name: &lt;%= name %&gt; image: &lt;%= image %&gt; ports: - containerPort: 80 opts = [namespace: &quot;default&quot;, name: &quot;nginx&quot;, image: &quot;nginx:nginx:1.7.9&quot;] resource = K8s.Resource.from_file!(&quot;priv/deployment.yaml&quot;, opts) operation = K8s.Client.create(resource) {:ok, conn} = K8s.Conn.lookup(:my_connection) {:ok, deployment} = K8s.Client.run(operation, conn)"},{"ref":"operations.html#listing-deployments","title":"HTTP Operations (K8s.Operation) - Listing Deployments","type":"extras","doc":"In a given namespace: operation = K8s.Client.list(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: &quot;prod&quot;) {:ok, conn} = K8s.Conn.lookup(:my_connection) {:ok, deployments} = K8s.Client.run(operation, conn) Across all namespaces: operation = K8s.Client.list(&quot;apps/v1&quot;, &quot;Deployment&quot;, namespace: :all) {:ok, conn} = K8s.Conn.lookup(:my_connection) {:ok, deployments} = K8s.Client.run(operation, conn) Note: K8s.Client.list will return a map. The list of resources will be under &quot;items&quot;."},{"ref":"operations.html#using-labelselector-with-list-operations","title":"HTTP Operations (K8s.Operation) - Using labelSelector with List Operations","type":"extras","doc":"K8s.Selector supports programatically building Kubernetes labelSelectors. {:ok, conn} = K8s.Conn.lookup(:my_connection) K8s.Client.list(&quot;apps/v1&quot;, :deployments) |&gt; K8s.Selector.label({&quot;app&quot;, &quot;nginx&quot;}) |&gt; K8s.Selector.label_in({&quot;environment&quot;, [&quot;qa&quot;, &quot;prod&quot;]}) |&gt; K8s.Client.run(conn)"},{"ref":"operations.html#getting-a-deployment","title":"HTTP Operations (K8s.Operation) - Getting a Deployment","type":"extras","doc":"{:ok, conn} = K8s.Conn.lookup(:my_connection) operation = K8s.Client.get(&quot;apps/v1&quot;, :deployment, [namespace: &quot;default&quot;, name: &quot;nginx-deployment&quot;]) {:ok, deployment} = K8s.Client.run(operation, conn)"},{"ref":"operations.html#watch-operations-k8s-client-runner-watch","title":"HTTP Operations (K8s.Operation) - Watch Operations (K8s.Client.Runner.Watch)","type":"extras","doc":"Watch operations use the Kubernetes Watch API to stream added, modified, and deleted as they occur. operation = K8s.Client.list(&quot;apps/v1&quot;, :deployment, namespace: :all) {:ok, conn} = K8s.Conn.lookup(:my_connection) {:ok, reference} = K8s.Client.watch(operation, conn, stream_to: self())"},{"ref":"operations.html#wait-on-a-resource-k8s-client-runner-wait","title":"HTTP Operations (K8s.Operation) - Wait on a Resource (K8s.Client.Runner.Wait)","type":"extras","doc":"The wait runner permits read operations to be made and block until a certain state is met in Kubernetes. This follow example will wait 60 seconds for the field status.succeeded to equal 1. operation = K8s.Client.get(&quot;batch/v1&quot;, :job, namespace: &quot;default&quot;, name: &quot;database-migrator&quot;) wait_opts = [find: [&quot;status&quot;, &quot;succeeded&quot;], eval: 1, timeout: 60] {:ok, conn} = K8s.Conn.lookup(:my_connection) {:ok, job} = K8s.Client.wait(op, conn, wait_opts) :find and :eval also accept functions to apply to check success."},{"ref":"operations.html#async-batch-operations-k8s-client-runner-async","title":"HTTP Operations (K8s.Operation) - Async Batch Operations (K8s.Client.Runner.Async)","type":"extras","doc":"An async runner is provided for running operations in parallel. All operations are fired async and their results are returned. Processing does not halt if an error occurs for one operation. operation1 = K8s.Client.get(&quot;v1&quot;, &quot;Pod&quot;, namespace: &quot;default&quot;, name: &quot;pod-1&quot;) operation2 = K8s.Client.get(&quot;v1&quot;, &quot;Pod&quot;, namespace: &quot;default&quot;, name: &quot;pod-2&quot;) {:ok, conn} = K8s.Conn.lookup(:my_connection) results = K8s.Client.async([operation1, operation2], conn) results will be a list of :ok and :error tuples."},{"ref":"operations.html#list-operations-as-elixir-streams-k8s-client-runner-stream","title":"HTTP Operations (K8s.Operation) - List Operations as Elixir Streams (K8s.Client.Runner.Stream)","type":"extras","doc":"A stream runner is provided to automatically handle pagination in K8s.Client.list/3 operations. operation = K8s.Client.list(&quot;v1&quot;, &quot;Pod&quot;, namespace: :all) {:ok, conn} = K8s.Conn.lookup(:my_connection) operation |&gt; K8s.Client.stream(conn) |&gt; Stream.filter(&amp;my_filter_function?/1) |&gt; Stream.map(&amp;my_map_function?/1) |&gt; Enum.into([])"},{"ref":"middleware.html","title":"Middleware (K8s.Middleware)","type":"extras","doc":"Middleware (K8s.Middleware) K8s.Middleware is registered by connection name. By default a few pieces of middleware are registered for all connections. K8s.Middleware.Request.Initialize K8s.Middleware.Request.EncodeBody"},{"ref":"middleware.html#request-middleware","title":"Middleware (K8s.Middleware) - Request Middleware","type":"extras","doc":"Middleware can be added to a connection or the entire middleware stack can be replaced. Adding Request Middleware Given a registered K8s.Conn named :foo the following example will add ExampleMiddleware to the end of the middleware stack K8s.Middleware.Registry.add(:foo, :request, MyMiddlewareModule) Replacing the Middleware Stack Given a registered K8s.Conn named :foo the following example will replace the middleware stack. K8s.Middleware.Registry.set(:foo, :request, [MyMiddlewareModule]) Listing Middleware for a K8s.Conn K8s.Middleware.Registry.list(:foo, :request) [K8s.Middleware.Request.Initialize, K8s.Middleware.Request.EncodeBody] Writing Request Middleware K8s.Middleware.Request is a behaviour and struct for encapsulating requests processed by the middleware stack. Middleware is expected to return {:ok, %Request{}} to continue processing or {:error, :my_error} to halt. The error in the error tuple can be an atom or a struct. It will automatically be wrapped in K8s.Middleware.Error during processing. To implement a piece of middleware, you need to define a function call/1 that accepts a K8s.Middleware.Request. The example below will automatically add labels to a :post requests. def call(%Request{method: :post, body: body} = req) do metadata = Map.get(body, &quot;metadata&quot;, %{}) metadata_with_labels = Map.put(metadata, &quot;labels&quot;, %{&quot;env&quot; =&gt; &quot;prod&quot;}) updated_body = Map.put(body, &quot;metadata&quot;, metadata_with_labels) request_with_labels = %Request{req | body: updated_body} {:ok, request_with_labels} end"},{"ref":"middleware.html#response-middleware","title":"Middleware (K8s.Middleware) - Response Middleware","type":"extras","doc":"Response middleware has not been implemented at this time."},{"ref":"authentication.html","title":"Authentication K8s.Conn.Auth","type":"extras","doc":"Authentication K8s.Conn.Auth k8s features pluggable authentication, but includes 3 strategies in the order of attempted application: K8s.Conn.Auth.Certificate certificate based authentication K8s.Conn.Auth.Token token based authentication K8s.Conn.Auth.AuthProvider implements a Kubernetes config file&#39;sauth-provider functionality. A few notes first: K8s.Conn.Auth.AuthProvider is itself an authentication strategy that allow shell calls to provide a Bearer Token. It&#39;s unfortunately named, but the names of the modules follow the key names in a Kubernetes config file. More on this strategy can be found here. The K8s.Conn struct encapsulates a connection to a cluster. It has the cluster address as well as how to authenticate to the cluster. K8s.Conn structs can be constructed manually, but there are a few helpers here to create one. The K8s.Conn.Auth.Token auth strategy is probably the simplest strategy to review as a reference implementation."},{"ref":"authentication.html#custom-authentication-providers","title":"Authentication K8s.Conn.Auth - Custom Authentication Providers","type":"extras","doc":"Two things are required to implement a custom auth strategy: Implement the K8s.Conn.Auth behaviour for auth strategies. The first strategy to return an K8s.Conn.Auth struct will be chosen. Any that cannot authenticate the connection should return nil. Implement the K8s.Conn.RequestOptions protocol which should create a RequestOptions struct. This struct is used to set HTTP Headers and SSL connection options. Looking at the Token example: Line 13 implements the case where this auth strategy would be able to generate request options Line 14 implements the default case where it cannot authenticate the request Lines 19-24 implement how to generate HTTP Headers and SSL options to be used by HTTPoison to make the HTTP requests."},{"ref":"authentication.html#using-a-custom-authentication-provider","title":"Authentication K8s.Conn.Auth - Using a Custom Authentication Provider","type":"extras","doc":"Authentication providers are traversed in order. The first provider to return an K8s.Conn.Auth struct is used. Default providers are checked after any providers supplied to in the Mix config key :auth_providers: config :k8s, auth_providers: [CustomProvider1, CustomProvider2] This would result in authentication attemps in the following order: CustomProvider1 CustomProvider2 K8s.Conn.Auth.Certificate K8s.Conn.Auth.Token K8s.Conn.Auth.AuthProvider"},{"ref":"testing.html","title":"Testing","type":"extras","doc":"Testing k8s supports a few mechanisms to stub Kubernetes HTTP requests when developing or testing locally."},{"ref":"testing.html#mocking-api-version-and-resource-discovery","title":"Testing - Mocking API Version and Resource Discovery","type":"extras","doc":"TODO doc: K8s.Discovery.Driver.File"},{"ref":"testing.html#mocking-http-responses","title":"Testing - Mocking HTTP Responses","type":"extras","doc":"TODO doc: K8s.Client.DynamicHTTPProvider"},{"ref":"discovery.html","title":"Discovery (K8s.Discovery)","type":"extras","doc":"Discovery (K8s.Discovery) k8s supports just-in-time discovery of cluster APIs and resource kinds. This is important because depending on the CRDs, Kubernetes version, and enabled APIs, URL paths can vary. The goal of the k8s library was to support multiple clusters without the need to generate code from Kubernetes swagger files. This makes the library more portable and easier to use with various clusters. K8s.Discovery is pluggable. It was designed in this manner to ease testing. The K8s.Discovery.Driver.HTTP driver is probably the only driver you will need to use in development and production. A file driver (K8s.Discovery.Driver.File) is also provided. This is used in the test suite to &quot;stub&quot; discovery without making HTTP requests. The file driver could also be used in the scenario that you want to limit calls to the Kubernetes masters either out to reduce the number of HTTP calls or for security if the master&#39;s API metadata is inaccessible (kubectl api-versions, kubectl api-resources)."},{"ref":"discovery.html#using-the-discovery-module","title":"Discovery (K8s.Discovery) - Using the Discovery module","type":"extras","doc":"Discovery is done automatically during HTTP requests, but the module can also be used directly. Available functions are: K8s.Discovery.versions/2 - list API versions of the cluster K8s.Discovery.resources/3 - list resource kinds of a specific API K8s.Discovery.url_for/2 - Generate the URL for a K8s.Operation on a specific K8s.Conn"},{"ref":"discovery.html#setting-the-default-driver","title":"Discovery (K8s.Discovery) - Setting the Default Driver","type":"extras","doc":"Drivers can be set via a Mix config. A default driver can be specified as well as a driver per registered connection. discovery_driver and discovery_opts control the default driver to use. If not set, the HTTP driver will be used with an empty keyword list. Below the file driver is set as the default using &quot;test/support/discovery/example.json&quot; as the configuration file (see Using the File Driver below). use Mix.Config config :k8s, discovery_driver: K8s.Discovery.Driver.File, discovery_opts: [config: &quot;test/support/discovery/example.json&quot;], clusters: %{ test: %{ conn: &quot;test/support/kube-config.yaml&quot; } }"},{"ref":"discovery.html#setting-drivers-per-connection","title":"Discovery (K8s.Discovery) - Setting Drivers per Connection","type":"extras","doc":"Drivers can also be set per connection. In the example below the :test and :dev connections are using the default File driver, while the :prod connection is using the HTTP driver with caching enabled. use Mix.Config config :k8s, discovery_driver: K8s.Discovery.Driver.File, discovery_opts: [config: &quot;test/support/discovery/example.json&quot;], clusters: %{ test: %{ conn: &quot;test/support/kube-config.yaml&quot;, conn_opts: [context: &quot;test-context&quot;] }, dev: %{ conn: &quot;test/support/kube-config.yaml&quot;, conn_opts: [context: &quot;dev-context&quot;] }, prod: %{ use_sa: true, conn_opts: [ discovery_driver: K8s.Discovery.Driver.HTTP, discovery_opts: [cache: true] ] } }"},{"ref":"discovery.html#using-the-http-driver-k8s-discovery-driver-http","title":"Discovery (K8s.Discovery) - Using the HTTP Driver (K8s.Discovery.Driver.HTTP)","type":"extras","doc":"The HTTP driver is used by default. When a K8s.Operation is run calls to /api and /apis are made to discovery what resources, versions, and scope are supported for resources. The HTTP driver can also be used directly to explore API support. List supported versions: {:ok, conn} = K8s.Conn.lookup(:my_connection) K8s.Discovery.Driver.HTTP.versions(conn) [&quot;v1&quot;, &quot;apps/v1&quot;, &quot;batch/v1&quot;] List supported resources of an API version. {:ok, conn} = K8s.Conn.lookup(:my_connection) K8s.Discovery.Driver.HTTP.resources(&quot;apps/v1&quot;, conn) [ { &quot;kind&quot;: &quot;DaemonSet&quot;, &quot;name&quot;: &quot;daemonsets&quot;, &quot;namespaced&quot;: true, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] }, { &quot;kind&quot;: &quot;Deployment&quot;, &quot;name&quot;: &quot;deployments&quot;, &quot;namespaced&quot;: true, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] } # ... ]"},{"ref":"discovery.html#using-the-file-driver-k8s-discovery-driver-file","title":"Discovery (K8s.Discovery) - Using the File Driver (K8s.Discovery.Driver.File)","type":"extras","doc":"The file driver is primarly intended for testing. The format for a driver configuration file is a JSON file with API version as the key to a list of resource metadata. { &quot;v1&quot;: [ { &quot;kind&quot;: &quot;Namespace&quot;, &quot;name&quot;: &quot;namespaces&quot;, &quot;namespaced&quot;: false, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] } ], &quot;apps/v1&quot;: [ { &quot;kind&quot;: &quot;Deployment&quot;, &quot;name&quot;: &quot;deployments&quot;, &quot;namespaced&quot;: true, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] } ] }"}]